<?php 
// fonctions du CRM chargées dans l'index
//Script de sécurité, les données générées doivent être stockées dans une colonne de type text
//cryptage des données sensibles
function dlw_enc($data=null){
	if (!empty($data)){
		$iv = substr(bin2hex(openssl_random_pseudo_bytes(openssl_cipher_iv_length('AES-256-CBC'))),0,16);
		$dataencrypt = openssl_encrypt(htmlspecialchars($data),'aes256',CONFIG_key, 0,$iv);
		return $dataencrypt.$iv;
	};
}

//decryptage des données
function dlw_dec($data=null){
	if (!empty($data)){
		$data_enc= substr($data, 0,-16);
		$iv_enc= substr($data,-16);
		$datadecrypt = openssl_decrypt($data_enc,'aes256',CONFIG_key, 0,$iv_enc);
		return stripcslashes(htmlspecialchars_decode($datadecrypt));
	}else{
		return "";
	};		
}

// création de session et definiton des accès en 
// données d'entrées data issues d'une requete SQL cherchant un user
// ou id qui générera la requete SQL
function dlw_session($verif){
    //on cherche l'utilisateur à partir de son id
    global $db;
    global $presql;  
    $sql = "select * from ".$presql."_users
			LEFT JOIN ".$presql."_groups ON ".$presql."_users.ids_group=".$presql."_groups.id_group
			WHERE id_user='".$verif."'";
    $req = mysqli_query($db, $sql);
    $data = mysqli_fetch_assoc($req);     
    
    $_SESSION['id'] = $data['id_user'];
	$_SESSION['name'] = $data['name'];
	$_SESSION['droit'] = $data['droit'];
	$_SESSION['firstname'] = $data['firstname'];
	$_SESSION['email'] = $data['email'];
	$_SESSION['telephone'] = $data['telephone'];
	$_SESSION['ids_group'] = $data['ids_group'];
	$_SESSION['groupname'] = $data['groupname'];
	$_SESSION['passwd'] = $data['passwd'];
	$_SESSION['couleur'] = dlw_dec($data['couleur']);
	
	$data['theme']=dlw_dec($data['theme']);
	$graphisme = explode(';',$data['theme']);
	
	$_SESSION['style'] = $graphisme[0];
	$_SESSION['theme'] = $graphisme[1];

    if (isset($_COOKIE['email'])){
        $temps = 365*24*3600;
        setcookie ("email", $data['email'], time() + $temps, "/");
        setcookie ("passwd", $data['passwd'], time() + $temps, "/");
    };
    
};


// recherche des modules accessibles par l'utilisateur, listé dans un tableau
// la vérification s'effectue dans l'index à chaque chargement de page
function dlw_accesmodule(){
    //on cherche l'utilisateur à partir de son id
    global $db;
    global $presql;  
	$sqlmod = "select * from ".$presql."_modules ORDER BY ordre";
	$reqmod = mysqli_query($db, $sqlmod);
	$droitmod=array();
	while ($modverif = mysqli_fetch_assoc($reqmod)){
		// on explose le résultat
		$verif_droit_page=explode(";",$modverif['acces']);
		foreach($verif_droit_page as $val){
			// on vérifie si le groupe utilisateur est dans le tableau explode, si oui on ajout une entrée dans un tableau d'accès
			// et on quitte, l'id du group ne pouvant être explosé plusieurs fois
			if($val == $_SESSION['ids_group'] AND !empty($val)){
				$droitmod[$modverif['dossier']]=strtolower($modverif['name']);
				
				if (!empty($modverif['titre'])){
					$droitmod[$modverif['dossier'].'_titre']=$modverif['titre'];
				}else{
					$droitmod[$modverif['dossier'].'_titre']=$modverif['name'];
				}
				
			break;};	
		};
	};
	// on retourne le tableau, il suffira de vérifier ce tableau pour afficher le nav pour les options/inclusions dans les pages
	return $droitmod;
};


//vérification d'utilisateurs existants
function dlw_verif_user($data){
	global $db;
	global $presql;
	$sqlverif = "select * from ".$presql."_users";
  	$reqverif = mysqli_query($db, $sqlverif);
  	// on verifie chaque email utlisateur à cause de l'encryption
  	while ($userverif = mysqli_fetch_assoc($reqverif)){
		if((dlw_dec($userverif['email']) == $data) OR (md5($userverif['email']) == $data)) {
			$verif = $userverif;
			break;
	}};
	if(isset($verif)){return $verif;}else{return false;}
};


//vérification de la version sur serveur YUCCA
function dlw_verif_version(){
	
	global $db;
	global $presql;
	
	$sqlvinstall = "select param_value from ".$presql."_params WHERE param_name = 'version'";
	$reqvinstall = mysqli_query($db, $sqlvinstall);	
	$datavinstall = mysqli_fetch_assoc($reqvinstall);
	
	//changement d'url de vérification de l'update par hook
	$updateurl = hook('url_update');
	if ( empty($updateurl) ){ $updateurl = "https://yucca-crm.fr/Yucca-release"; };	
	
	//telecharger le zip, rediriger suivant succes ou echec
	$url = 	$updateurl."/update.php?v=".$datavinstall['param_value'];

	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	$response = curl_exec($ch);
	$error = curl_error($ch);
	curl_close($ch);
	
	if ($response) 
	{
		$result = json_decode($response,TRUE);
		mysqli_query($db, "UPDATE ".$presql."_params SET param_value = '".$result."' WHERE param_name = 'update'");
		
	};
	
	return $result;
	
};

//Compartif des versions - installée et disponible
function dlw_compare_version(){
	
	//recupérer les infos depuis la bdd
    global $db;
    global $presql;  
    
	$sqlvinstall = "select param_value from ".$presql."_params WHERE param_name = 'version'";
	$reqvinstall = mysqli_query($db, $sqlvinstall);	
	$datavinstall = mysqli_fetch_assoc($reqvinstall);
		
	$sqlvrelease = "select param_value from ".$presql."_params WHERE param_name = 'update'";
	$reqvrelease = mysqli_query($db, $sqlvrelease);	
	$datavrelease = mysqli_fetch_assoc($reqvrelease);	
	
	if(version_compare($datavinstall['param_value'], $datavrelease['param_value'], '<')) {
						
		echo "<li><a class='update' href='/mise-a-jour' title='nouvelle version'><span>".$datavrelease['param_value']."</span></a></li>";
		 
	};				
	
};

function dlw_get_style(){
    //on cherche l'utilisateur à partir de son id
    global $db;
    global $presql;  
	$sqlmod = "select * from ".$presql."_modules";
	$reqmod = mysqli_query($db, $sqlmod);

	while ($modverif = mysqli_fetch_assoc($reqmod)){

		if ( file_exists( ABSPATH ."/modules/".$modverif['dossier']."/style/style.php") ){
			
			include_once ( ABSPATH ."/modules/".$modverif['dossier']."/style/style.php");
			
		};

	};
};


function dlw_get_script(){
    //on cherche l'utilisateur à partir de son id
    global $db;
    global $presql;  
	$sqlmod = "select * from ".$presql."_modules";
	$reqmod = mysqli_query($db, $sqlmod);

	while ($modverif = mysqli_fetch_assoc($reqmod)){

		if ( file_exists( ABSPATH ."/modules/".$modverif['dossier']."/functions/script.php") ){
			
			include_once ( ABSPATH ."/modules/".$modverif['dossier']."/functions/script.php");
			
		};

	};
};

function dlw_get_cron(){
	
    global $db;
    global $presql;  
	$sqlmod = "select * from ".$presql."_modules";
	$reqmod = mysqli_query($db, $sqlmod);

	while ($modverif = mysqli_fetch_assoc($reqmod)){
		
		if ( file_exists( ABSPATH ."/modules/".$modverif['dossier']."/functions/cron.php") ){
			
			include_once ( ABSPATH ."/modules/".$modverif['dossier']."/functions/cron.php");
			
		};	

	};
};



//appel asynchrone php
function callasync($url){
	$cmi = curl_multi_init();
	$curl = curl_init();
	curl_setopt($curl, CURLOPT_URL, $url);
	curl_multi_add_handle($cmi, $curl);
	
	do {
		curl_multi_exec($cmi, $running);
		//on attends quelques micro secondes puis on break la boucle.
		//comme ça on arrive a appeler l'url sans attendre la réponse  
		usleep(1000);
		break;
	} while ($running > 0);
	
	curl_multi_remove_handle($cmi, $curl);
	curl_multi_close($cmi);
};

//deconnexion
function dlw_deconnexion(){
	setcookie("email",'', time() - 3600,'/');
	setcookie("passwd",'', time() - 3600,'/');
	$_SESSION = array();
	session_destroy();
	session_start ();
};

//suppression des accents pour enregistrement des documents
function dlw_accents( $str, $doc='0',$charset='utf-8' ) {
 
    $str = htmlentities( $str, ENT_NOQUOTES, $charset );
    
    $str = preg_replace( '#&([A-za-z])(?:acute|cedil|caron|circ|grave|orn|ring|slash|th|tilde|uml);#', '\1', $str );
    $str = preg_replace( '#&([A-za-z]{2})(?:lig);#', '\1', $str );
    $str = preg_replace( '#&[^;]+;#', '', $str );

    //suppression des espaces dans les noms des documents uniquement
    if($doc==1){
		
		//_ et maj
		$str = str_replace( ' ', '_', strtoupper($str) );
		
	}else if($doc==2){
		 //maj uniquement
		$str = strtoupper($str);
		
	}else if($doc==3){
		
		//_ et min
		$str = str_replace( ' ', '_', strtolower($str));
		
	}else if($doc==4){
		
		//- et min
		$str = str_replace( ' ', '-', strtolower($str));	
		
	}else if($doc==5){
		
		//min
		$str = strtolower($str);			
		
	};	
	
    return $str;
};

//formatage des liens vers les dossiers Nextcloud
function dlw_foldercloud($str) {
	
	//décodage
	$dec_str = dlw_dec($str);

	//encodage avec exclusion des /
	$raw_str = implode('/', array_map(function ($v) {
		return rawurlencode($v);
	}, explode('/', $dec_str)));
	
    return $raw_str;
};



//suppression d'un module
function supp_mod($mod) { 
     $objects = scandir( ABSPATH ."/modules/".$mod);
     foreach ($objects as $object) { 
       if ($object != "." && $object != "..") { 
         if (is_dir( ABSPATH ."/modules/".$mod."/".$object) && !is_link( ABSPATH ."/modules/".$mod."/".$object))
           supp_mod($mod."/".$object);
         else
           unlink( ABSPATH ."/modules/".$mod."/".$object); 
       } 
     }
     rmdir( ABSPATH ."/modules/".$mod); 
}

//statistiques

function get_random_color(){

	$arraycolor = ["2","4","5","6","7"];
    $color = $arraycolor[array_rand($arraycolor)];
    
	return $color;
}


function stat_circle($taux,$demi=0){
	
	//conversion en array
	if ( !is_array($taux) ){
		$taux = [$taux];
	};
	
	//suppression des valeurs nulles
	$taux = array_filter($taux, function($value) {
		$pourcent = explode('|',$value);
		return ($pourcent[0] != 0 && $pourcent[0] != '');
	});

	//centrage des ecritures suivant le nombre d'entrées dans l'array
	$arrLength = count($taux) -1 ;
	//return count($taux);exit;
	if ( count($taux) == 0 ){$taux = array("0| Aucune donnée");$arrLength=0;}

	$rapport = 0.55 ;
	$sizeMax = 3 - ( $arrLength * 0.13 ) ;
	$pos = 50 + ( $arrLength * $sizeMax * 1.5  );
	$arraysvg = array();
	$color=$txt="";
	$value=0;
	
	//demi-cercle
	if ( $demi == 1 ) {
		
		$viewbox = "0 16 32 16";
		$demiclass="duo";
		
	}else{
		
		$viewbox = "0 0 32 32";
		$demiclass="";
	};
	
	$svg = '<svg class="statcircle '.$demiclass.'" viewBox="'.$viewbox.'">';
	
	
	foreach ($taux as $pourcent){
		
		$pourcent = explode('|',$pourcent);
		//largeur max de la ligne
		$sizeLenghtMax = ( 15 - ( abs( $pos - 50 ) * 0.3 ) );

		//nombre de lettres à afficher
		$numberLetter = strlen( $pourcent[1].round($pourcent[0],1).'%');
		if( isset( $pourcent[2] ) ){ $numberLetter += 2;}else{ $pourcent[2]=""; };
		
		
		//demicercle
		$pourcent[0] = ( $demi == 1 ) ? $pourcent[0]/2 : $pourcent[0];

		$sizeText = $sizeMax;
		$sizeLenght = $sizeText * $numberLetter * $rapport;		

		//si trop de lettres il faut reduire la largeur
		if ( $sizeLenght > $sizeLenghtMax ) {
			
			$sizeLenght = $sizeLenghtMax;
			$sizeText = $sizeLenght / ( $numberLetter * $rapport );
			
		};
		
		//si les lettres sont trop grandes on les passes au max size et on recalcul la largeur
		$colorprec=$color;
		while ($colorprec == $color){$color = get_random_color();};
		$value += $pourcent[0];
		if ( round($value,1) == 100){ $value = 101; }
		else if ( round($value,1) == 50 AND $demi == 1){ $value = 51; };

		$thisname = dlw_enc( $pourcent[0] );
		$arraysvg [] =  '<g class="statcouleur'.$color.'"><circle  cx="16" cy="16" r="16" class="first" stroke-dasharray="'.round($value,1).' 100" data-name="'.$thisname.'"></circle></g>';
		
		//demi-cercle
		if ( $demi == 1 ) {
			
			$x ="-50%";
			$y = "-".( $pos * 2.4 )."%";
			
		}else{
			
			$x ="50%";
			$y = "-".$pos."%";
			
		};
		
		//texte demi x2
		$pourcent[0] = ( $demi == 1 ) ? $pourcent[0]*2 : $pourcent[0];

		$txt .=  '<g class="statcouleur'.$color.'"><text class="statvalue" font-size="'.$sizeText.'" x="'.$x.'" y="'.$y.'" dominant-baseline="middle" text-anchor="middle" data-name="'.$thisname.'" textLength="'.$sizeLenght.'" lengthAdjust="spacingAndGlyphs"> <tspan>'.$pourcent[2].'</tspan> '.$pourcent[1].' '.round($pourcent[0],1).'%</text></g>';
		$pos -= ( $sizeMax * 3 );
	};
	
	$arraysvg = array_reverse($arraysvg);
	foreach ($arraysvg as $circle){
		$svg .= $circle;	
	}
	
	if (  $_SESSION['style'] == 'checked' ) {
		$svg .=  '<circle cx="16" cy="16" r="10" class="masque neuminset" stroke-dasharray="100 100"></circle>'.$txt.'</svg>';
	}else{
		$svg .=  '<rect x="6" y="6" width="20" height="20" class="masque neuminset" stroke-dasharray="100 100" />'.$txt.'</svg>';
	};
		
	return $svg;

}

function stat_bar_h($taux){
	
	
	if (is_nan($taux)){$taux=0;};
	
    $color = get_random_color();

	$pos = $taux+2;
	$svg = '<svg class="neum statbar statcouleur'.$color.'" viewBox="0 0 118 12">
		<path class="first" d="M 0,0 H 100" stroke-width="100%" stroke-dasharray="'.$taux.' 100"/>
		<text class="statvalue" font-size="5" x="'.$pos.'" y="6.5" dominant-baseline="middle">'.round($taux,1).'%</text>
	</svg>';
	return $svg;
}

function stat_bar_v($taux){
	
	if (is_nan($taux)){$taux=0;};
	
    $color = get_random_color();
    	
	$svg = '<svg class="statbar statcouleur'.$color.'" viewBox="0 0 10 100">
		<path class="first" d="M 0,0 H 100" stroke-width="100%" stroke-dasharray="'.$taux.' 100"/>
	</svg>';
	return $svg;
}

function stat_bar_proj($taux){
	
	if (is_nan($taux)){$taux=0;};
	
    $color = get_random_color();

	$svg = '<svg class="statbar statcouleur'.$color.'" viewBox="0 0 100 0.1">
		<path class="first" d="M 0,0 H 100" stroke-width="100%" stroke-dasharray="'.$taux.' 100"/>
	</svg>';
	return $svg;
}

function big_number($number,$mod=null){
	
	$number=floatval($number);
    $color = get_random_color();
    
    if (fmod($number, 1) !== 0.00) {
		// The number has a decimal part
		$pos = strlen($number)*4.2;
	} else {
		// The number is an integer
		$pos = strlen($number)*5.1;
	}

    if ($mod){$width = strlen($mod) + $pos;}else{$width=$pos;}
    
	$svg = '<svg class="number statcouleur'.$color.'" viewBox="0 0 '.$width.' 6.8">
		<text class="statvalue" x="0" y="4.5" font-size="8" font-weight="bold" dominant-baseline="middle">'.round($number,1).'</text>
		<text y="4.5" x="'.$pos.'" font-size="8" dominant-baseline="middle"> '.$mod.'</text>
	</svg>';
	return $svg;
}

function stat_progress($taux){
	if (!is_infinite($taux)){
		
		if (is_nan($taux)){$taux=0;};

		if ($taux==0){$div='<span class="na"><i class="fa-solid fa-arrows-left-right"></i></span>';}
		else if ($taux <= 0){$div='<span class="neg">'.abs( $taux ).'% <i class="fa-solid fa-arrow-trend-down"></i></span>';}
		else {$div='<span class="pos">'.$taux.'% <i class="fa-solid fa-arrow-trend-up"></i></span>';}
		return $div;
	};
}

function stat_graph($data, $bar_spacing = 5)
{
  // calculer le nombre d'années
  $num_years = count($data);

  // trouver la valeur maximale pour la donnée
  $max_value = 1;
  foreach ($data as $year_data) {
    if ($year_data['value'] > $max_value) {
      $max_value = $year_data['value'];
    }
  }

  // calculer la largeur de chaque barre
  $bar_width = (200 - ($num_years - 1) * $bar_spacing) / $num_years;

  // générer le code SVG pour le graphique
  $svg = '<svg class="statgraph" viewBox="0 0 200 100" xmlns="http://www.w3.org/2000/svg">';
  $x = 0;

  foreach ($data as $year_data) {
	   
	$color = get_random_color();
	
	//rayon suivant thème
	$rx = 0;
	if (  $_SESSION['style'] == 'checked' ) { $rx = 6; };
	
    $bar_height = ($year_data['value'] / $max_value) * 100; // la hauteur de la barre est proportionnelle à la valeur et à la hauteur maximale
    $y = 100 - $bar_height; // la hauteur doit être inversée pour que le haut de la barre soit à l'axe des ordonnées
	
    $svg .= '<rect x="'.$x.'" y="'.$y.'" width="'.$bar_width.'" height="'.(100-$y).'" rx='.$rx.' class="rectcouleur'.$color.'"/>';
    $svg .= '<text x="'.($x+$bar_width/2).'" y="'.($y+10).'" text-anchor="middle" font-size="6">'.$year_data['value'].'</text>';
    $svg .= '<text x="'.($x+$bar_width/2).'" y="95" text-anchor="middle" font-size="4">'.$year_data['year'].'</text>';
    $x += $bar_width + $bar_spacing; // mettre à jour la position x pour la prochaine barre
    
  }
  $svg .= '</svg>';

  return $svg;
};


/*récupération des images utilisateurs ou par défault*/
function get_logo(){
	if (file_exists( ABSPATH ."/img/logo.png")){
		return "logo.png";
	}else{
		return "logo-ori.png";
	};
};


//Test REST, renvoi la liste des contacts dans la base de données Yucca
function testrest(){
	
	global $db;
	global $presql;

	$i=0;
	$reponse=array();
	
	$sql = "select * from ".$presql."_yucca_contact";
	$req = mysqli_query($db, $sql);

	while ($data = mysqli_fetch_assoc($req)){

		//envoi des données cryptées, à décrypter dans Worpdress
		$reponse[$i]['prenom']= $data['name'];
		$reponse[$i]['nom']= $data['firstname'];
		$reponse[$i]['email']= $data['email1'];
		$i++;

	};

	echo json_encode($reponse, JSON_PRETTY_PRINT);
};


//récupère les données de config depuis le fichier config.php et l'envoi sous forme de tableau
function get_config($param=NULL){
	
	$this_config = file_get_contents( ABSPATH ."/admin/config.php");
	
	//extraction des paramètres
	$regex="/\)\)\{define\(\"CONFIG_(.*?)\", \"(.*?)\"\);/";
	preg_match_all($regex, $this_config, $tab_config);
	
	//mise en forme du tableau
	$i=0;
	foreach ($tab_config[0] as $key){
		
		$donnees[$tab_config[1][$i]]=$tab_config[2][$i];
		$i++;
				
	};	
	
	//retour du tableau des paramètres
	if ($param==NULL){

		return $donnees;
	
	//ou retour de la valeur demandée
	}else if (isset($donnees[$param])){
		
		return $donnees[$param];
		
	};
}


//recherche les fonctions hookées
function hook($hook){
	
	global ${'hook_functions_'.$hook};
	
	if(isset(${'hook_functions_'.$hook})){
		
		//tri du tableau pour la gestion des priorités
		asort(${'hook_functions_'.$hook});
		
		//execution des fonctions dans l'ordre des priorités
		foreach ( ${'hook_functions_'.$hook} as $run){
			return $run();
		}
	};
	
};

//recherche les fonctions hookées
function add_action($hook,$function,$priorite){
	
	global ${'hook_functions_'.$hook};	
	${'hook_functions_'.$hook}[$priorite]=$function;
	
};

//fonction de génération d'input depuis une fiche module
// $array est le nom du tableau en requete initial afin de faire un echo des valeurs enregistrées en BDD
/* $type
 * 1:text
 * 2:texarea
 * 3:date
 * 4:switch bouton
 * 5:select
 * 6:fake input
*/
function autoQuery($arrayQuery,$type,$inputname,$class=null,$icon=null,$arraySelect=null){
		
	//inputname prend en argument un tableau si le placeholder est différent du name
	if (is_array($inputname)){
		
		$name = htmlspecialchars( dlw_accents($inputname[0],3) );
		$placeholder = $inputname[1];
		
	}else{
		
		$name = htmlspecialchars( dlw_accents($inputname,3) );
		$placeholder = $inputname;
	}
	
	//verification de la valeur
	$valeur = "";
	
	if ( array_key_exists('autoQuery'.$type.'_'.$name, $arrayQuery) ) {
		switch ($type) {
			
			case 1:
			case 2:
				$valeur = dlw_dec($arrayQuery['autoQuery'.$type.'_'.$name]);
			break;			
			case 6:
				if ($arraySelect){
					$valeur = $arraySelect;
				}else{
					$valeur = dlw_dec($arrayQuery['autoQuery'.$type.'_'.$name]);
				};
			break;
			case 3:
				if (!empty($arrayQuery['autoQuery'.$type.'_'.$name])){
					$valeur = date("Y-m-d",strtotime($arrayQuery['autoQuery'.$type.'_'.$name]));
				};
			break;
			
			case 4:	
			case 5:
				$valeur = $arrayQuery['autoQuery'.$type.'_'.$name];
			break;
			
			default:
			return;
				
		};		
		
	}
	$valeur = htmlspecialchars($valeur, ENT_QUOTES, 'UTF-8');
	
	$html = "<div class='divinput ".$class."'>";
	
	switch ($type) {
		
		case 1:
			$html .= "<label class='icon border-left' title='".$placeholder."'><i class='".$icon."'></i></label><input type='text' name='autoQuery".$type."_".$name."' value='".$valeur."' placeholder='".$placeholder."'/>";
		break;
			
		case 2:
			$html .= "<textarea  title='".$placeholder."' rows='1' name='autoQuery".$type."_".$name."' placeholder='".$placeholder."'>".$valeur."</textarea>";
		break;
		
		case 3:
			$html .= "<label class='icon border-left' title='".$placeholder."'><i class='fas fa-calendar'></i></label><input type='date' name='autoQuery".$type."_".$name."' value='".$valeur."' />";
		break;		
		
		case 4:
			($valeur == 1 OR $valeur == "on") ? $check = "checked":$check = "";
			$html .= "<label class='switch'><input type='checkbox' name='autoQuery".$type."_".$name."' ".$check."><span class='slider round border-left'></span></label><span class='border-right ".$check."'>".$placeholder."</span><input type='hidden' name='autoQuery".$type."_".$name."_hidden' value='1'>";
		break;
		case 5:
			$html .="<label class='icon border-left' title='".$placeholder."'><i class='".$icon."'></i></label><select name='autoQuery".$type."_".$name."'>";
			foreach ($arraySelect as $key => $value){
					$selected ="";
					if ( ( $key+1 ) == $valeur){$selected = "SELECTED";};
					$html .= "<option value='".($key+1)."' ".$selected.">".$value."</option>";
			};
			$html .= "</select>";
		break;	
		case 6:
			$html .="<label class='icon border-left' title='".$placeholder."' ><i class='".$icon."'></i></label><span class='fakeinput border-right'>".$valeur."</span><input type='hidden' name='autoQuery".$type."_".$name."' value='".$valeur."'>";
		break;
		default:
		return;
			
	};
	
	$html .= "</div>";
	echo $html;
};

//ajout des colonnes sql suivant les autoQuery pour une requete update
function autoQueryUpdate($arrayPost,$table){
	
	global $db;
	
	$thisQuery ="";
	$listTable = array();
	$resultat = mysqli_query($db, "SHOW COLUMNS FROM ".$table);
	while($row = mysqli_fetch_array($resultat)){
			$listTable[] = $row['Field'];
	}
	
	foreach ($arrayPost as $key => $value) {

        if ( ( substr($key, 0, 9) === "autoQuery" ) ) {	
			
			$type = substr($key, 9, 1);
						
			//la clé n'existe pas dans la table, on l'ajoute
			if ( ! array_search($key, $listTable) ) {
								
				switch ($type) {
					
					case 1:
					case 2:
					case 6:
						mysqli_query($db, "ALTER TABLE $table ADD COLUMN $key TEXT NULL");
					break;
						
					case 3:
						mysqli_query($db, "ALTER TABLE $table ADD COLUMN $key DATETIME NULL");
					break;
					
					case 4:
						$valueTrue = substr($key, 0, -7);
						
						if ( substr($key,-6) === "hidden" AND  !array_search($valueTrue, $listTable) ){

							mysqli_query($db, "ALTER TABLE $table ADD COLUMN $valueTrue int(4) NULL");

						};
					break;
					case 5:
						mysqli_query($db, "ALTER TABLE $table ADD COLUMN $key int(4) NULL");
					break;					
					
				};				
				
			};
								
			switch ($type) {
				
				case 1:
				case 2:
				case 6:
					$thisQuery .= $key."='".dlw_enc($value)."',";
				break;
					
				case 3:
					if ( !empty($value) ) {
						$value = date("Y-m-d",strtotime($value) );
						$thisQuery .= $key."='".$value."',";
					}else{
						$thisQuery .= $key."= NULL,";
					};
				break;
				
				case 4:	
					if ( substr($key,-6) === "hidden" ) {	
												
						// pour un checkbox, si l'input hidden exite seul c'est que le checkbox n'a pas été cochée
						// on vérifie donc la présence de l'input sans hidden et on écrit la valeur en conséquence.
						
						$valueTrue = substr($key, 0, -7); //suppression de "hidden"
						
						if ( isset($arrayPost[$valueTrue]) ){
							
							$thisQuery .= $valueTrue."='1',";
							
						}else{
							
							$thisQuery .= $valueTrue."='0',";
						};
					};
				break;
												
				case 5:
					$thisQuery .= $key."='".$value."',";
				break;
				default:
				return;
			};				
		};
    };
    
    //suppression de la dernière virgule
    return substr($thisQuery,0,-1);
    
};

//filtrage des colonnes pour une recherche
function autoQuerySearch($arrayPost,$op){
	
	global $db;
	$thisQuery =" ";

	foreach ( $arrayPost as $key => $value ) {
		
		if ( substr($key,-6) !== "hidden" AND substr($key, 0, 9) === "autoQuery" ) {	
			
			$type = substr($key, 9, 1);

			switch ($type) {
				case 1:
				case 2:
				case 6:
					$thisQuery .= $op." ".$key." = '".$value."' ";
				break;
				case 3:
					$value = date("Y-m-d",strtotime($value));
					$thisQuery .=  $op." ".$key."='".$value."' ";
				break;
				case 4:	
					$thisQuery .=  $op." ".$key."= '1' ";
				break;
				case 5:
					if ( $value != 1 ) { $thisQuery .=  $op." ".$key." = '".$value."' "; };
				break;
			};
		};
       
	};
    
    //suppression du premier AND
    return substr($thisQuery,4);

    
};


//affichage des info multiples dans les listes du CRM
function showData($data){
	
	$thisValue = "<i class='alert fa-solid fa-triangle-exclamation'></i>";	

	if (is_array($data)){
		
		foreach ($data as $key => $value) {

			if ( !empty($value) ) {
				
				$thisValue = $value;
				break;
			};
			
		};
	}else{
		
			if ( !empty($data) ) {
				
				$thisValue = $data;
				
			};		
		
	};
							
	echo $thisValue;

};

function ongletMenu($tab){
	$menu = "<div id='menuparam'>";
	$i=1;
	foreach($tab as $val){
		
		if ( 
			   ( $_SERVER['REQUEST_METHOD'] == 'POST' and $_POST['ongletactif'] == $val )
			OR ( $_SERVER['REQUEST_METHOD'] !== 'POST' and $i==1 )
			){
				
			$thisonglet='clickedbouton';
		}else{
			$thisonglet='';
		};
		$menu .= ' <a class="bouton ongletmodule '.$thisonglet.'" id='.$val.' href="#">'.ucfirst($val).'</a>';
		$i++;
	}
	
	$menu .= "</div>";
	
	echo $menu;
};

function utf8conv($str){
	$conv = iconv('UTF-8', 'windows-1252', $str);
	return $conv;
};
