<?php 
// fonctions du CRM spécifiques chargées dans l'index

//Génération d'un input select des structures par ordre alphabétique
function yucca_structure($id=NULL){
	global $db;
	global $presql;
	global $droitmod;
	$donnees = array();
	$sql= "select * from ".$presql."_yucca_structure";
	$req = mysqli_query($db, $sql);
	while ($result = mysqli_fetch_assoc($req)){
		if(!empty(dlw_dec($result['structure']))){
			$donnees[] = array(
				"id_structure" => $result['id_structure'],
				"structure" => strtoupper(dlw_dec($result['structure'])),
			);
		};
	};
	
	array_multisort( array_column($donnees, "structure"), SORT_ASC, $donnees );
	
	$list_entreprise =	'<label class="icon border-left"><i class="fas fa-building"></i></label><select name="pro" class="border-right">';
	$list_entreprise .=	'<option value="">+ '.$droitmod['yucca_structure_titre'].' *</option>';
	
	foreach ($donnees as $data) {
		if ($id==$data['id_structure']){
			$selected="selected";
			$boutonvoir='<a href="/'.$droitmod['yucca_structure'].'/fiche/'.$data['id_structure'].'" class="bouton visualiser border-right" title="Voir la fiche '.$droitmod['yucca_structure'].'"></a>';
		}else{$selected="";};
		$list_entreprise .= '<option value="'.$data['id_structure'].'" '.$selected.'>'.$data['structure'].'</option>';
	};
	$list_entreprise .=	'</select>';
	
	if ($id){
		$content='<div class="divinput inputstructure">'.$list_entreprise.$boutonvoir.'</div>';
		return $content;
	}else{
		return '<div class="divinput inputstructure">'.$list_entreprise.'</div>';		
	}
};

//création d'un dossier projet dans le cloud
function yucca_webdav($folder,$file){
	
	if( defined('CONFIG_lien_cloud') AND defined('CONFIG_dossier_cloud_doc') AND defined('CONFIG_name_cloud') AND defined('CONFIG_password_cloud') ){			

		//création des dossiers factures et devis dans le cloud suivant année en cours
		//a optimiser avec curl multi
		$folders=array(
		
			'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc),
			'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc)."Factures",
			'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc)."Devis",
			'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc)."Factures/".date('Y'),
			'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc)."Devis/".date('Y'),		

		);
			
		foreach($folders as $docfolder){
			
			$ch = curl_init();	
			curl_setopt($ch, CURLOPT_USERPWD, dlw_dec(CONFIG_name_cloud).":".dlw_dec(CONFIG_password_cloud));			
			curl_setopt($ch, CURLOPT_URL, $docfolder);
			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "MKCOL");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_BINARYTRANSFER, TRUE); // --data-binary
			$creatcloud = curl_exec ($ch);
			curl_close($ch);
		
		};
		
		$chdoc = curl_init();
		curl_setopt($chdoc, CURLOPT_URL, 'https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/webdav'.dlw_foldercloud(CONFIG_dossier_cloud_doc).$folder.$file);
		curl_setopt($chdoc, CURLOPT_USERPWD, dlw_dec(CONFIG_name_cloud).":".dlw_dec(CONFIG_password_cloud));
		curl_setopt($chdoc, CURLOPT_PUT, 1);
		$fh_res = fopen( ABSPATH .'/'.$file, 'r');
		curl_setopt($chdoc, CURLOPT_INFILE, $fh_res);
		curl_setopt($chdoc, CURLOPT_INFILESIZE, filesize( ABSPATH .'/'.$file));
		curl_setopt($chdoc, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($chdoc, CURLOPT_BINARYTRANSFER, TRUE); // --data-binary
		$curl_response_res=curl_exec ($chdoc);
		fclose($fh_res);
		curl_close($chdoc);

		// le fichier est sur le cloud, on incremente la variable d'étape
		if ($curl_response_res !== false){
			return "cloudok";
		}else{
			return "cloudnok";
		};
	}else{
			return "cloudnok";
	};
		
};

//Liste des intitulés de projets
function yucca_int_proj(){
	
		global $droitmod;

		$list = dlw_dec(CONFIG_int_projet);
		if(empty($list)){
			$list_projet='<a class="bouton ajouter" href="/configuration/parametres"> ajouter des libelles de '.$droitmod['yucca_projet_titre'].'</a>';
		}else{
			$intproj = explode(",", $list);
			$list_projet =	'<label class="icon border-left"><i class="fas fa-project-diagram"></i></label><select name="libelle" id="libelle" class="border-none">';
			$list_projet .=	'<option value="">+ '.ucfirst($droitmod['yucca_projet_titre']).' *</option>';
			foreach($intproj as $value){
				$list_projet .= '<option value="'.$value.'">'.ucfirst(strtolower($value)).'</option>';
			};
			$list_projet .=	'</select>';
		}
		return $list_projet;	
};


//Timer projet
function yucca_timer($id){
	
	global $db;
	global $presql;
	
	$sqltimer = "select hour_timer from ".$presql."_yucca_timer WHERE id_projet='".$id."'";
	$reqtimer = mysqli_query($db, $sqltimer);
	$fulltime=0;
	while ($datatimer = mysqli_fetch_assoc($reqtimer)) {$fulltime += $datatimer['hour_timer'];};
	$hour = floor($fulltime/60);
	$minutes = $fulltime - ($hour*60);
	
	$timer = '<div class="divtimer divinput"><div class="timermoins border-left">-</div><button class="bouton timer nowait" title="Timer"><span class="time">'.sprintf('%02d', $hour).':'.sprintf('%02d', $minutes).'</span><input type="hidden" name="idproj" value="'.$id.'" /></button><div class="timerplus border-right">+</div></div>';
	
	return $timer;
};

//Liste des produits
function yucca_produit(){
	
	global $db;
	global $presql;
	global $droitmod; 
	
	$list_prod =	'<select id="produit" class="border-left"><option tva="0">vide</option>';

	$sql= "select * from ".$presql."_yucca_produit";
	$req = mysqli_query($db, $sql);	
	
	while ($result = mysqli_fetch_assoc($req)){
				
		$list_prod .=	'<option desc="'.dlw_dec($result['desc_prod']).'" tarif="'.$result['tarif_prod'].'" tva="'.$result['tva_prod'].'">'.dlw_dec($result['title_prod']).'</option>';;

	};	
		
	$list_prod .=	'</select>';
	return $list_prod;	
};

//Génération d'un input select des structures par ordre alphabétique
function yucca_fournisseur($id=NULL){
	global $db;
	global $presql;
	global $droitmod; 
	
	if($id){
		$sql= "select * from ".$presql."_yucca_fournisseur where id_fournisseur = '".$id."'";
		$req = mysqli_query($db, $sql);
		$result = mysqli_fetch_assoc($req);
		
		return '<div class="divinput left avecbouton"><label class="icon"><i class="fas fa-user"></i></label><span class="fakeinput border-none">'.dlw_dec($result['fournisseur']).'</span><a href="/'.$droitmod['yucca_fournisseur'].'/fiche/'.$result['id_fournisseur'].'" class="border-right bouton visualiser" title="Voir la fiche"></a></div><input type="hidden" name="id_fournisseur" value="'.$id.'">';		

	}else{
		$sql= "select * from ".$presql."_yucca_fournisseur";
		$req = mysqli_query($db, $sql);
		while ($result = mysqli_fetch_assoc($req)){
			$donnees[] = array(
				"id_fournisseur" => $result['id_fournisseur'],
				"fournisseur" => strtoupper(dlw_dec($result['fournisseur'])),
			);
		};
		
		array_multisort( array_column($donnees, "fournisseur"), SORT_ASC, $donnees );
		
		$list_contact =	'<label class="icon"><i class="fas fa-user"></i></label><select name="id_fournisseur">';
		$list_contact .=	'<option value="">+ '.$droitmod['yucca_fournisseur_titre'].' *</option>';
		
		foreach ($donnees as $data) {
			if ($id == $data['id_fournisseur']){
				
				$selected="selected";
				
				$boutonvoir='<a href="/'.$droitmod['yucca_fournisseur'].'/fiche/'.$data['id_fournisseur'].'" class="bouton visualiser" title="Voir la fiche"></a>';
				
			}else{$selected="";};
			
			$list_contact .= '<option value="'.$data['id_fournisseur'].'" '.$selected.'>'.$data['fournisseur'].'</option>';
			
		};
		$list_contact .=	'</select>';
		
		if ($id){
			$content='<div class="divinput inputstructure">'.$list_contact.$boutonvoir.'</div>';
			return $content;
		}else{
			return '<div class="divinput">'.$list_contact.'</div>';		
		}		
		
	};
};

//Liste délai d'éxécution
function yucca_delaiexe($thisdelai=null){
		$list = dlw_dec(CONFIG_delai_devis);
		if(empty($list)){
			$list_projet='<a class="bouton ajouter fakeinput" href="/configuration/parametres"> Ajouter des délais d\'éxécution</a>';
		}else{
			$intproj = explode(",", $list);
			$list_projet =	'<select name="delai_proj">';
			foreach($intproj as $value){
				$list_projet .= '<option value="'.$value.'"';
				if ($thisdelai == $value){ $list_projet .= ' selected';};
				$list_projet .= '>'.ucfirst(strtolower($value)).'</option>';

			};
			$list_projet .=	'</select>';
		}
		return $list_projet;	
};


//décodage des champs pour fpdf
function yucca_decode_pdf($string=null){

	$decode=str_replace( "€", "SIGNEEURO",$string);
	$decode=utf8_decode($decode) ;
	$decode=str_replace( "SIGNEEURO", chr(128) ,$decode);
	$decode=stripslashes($decode);
	
	return $decode;	
};


//API rest espace client
//Infos user
function yucca_GetUserInfo($Email){
	
	global $db;
	global $presql;

	$reponse=array();
	
	$sql = "select * from ".$presql."_yucca_contact";
	$req = mysqli_query($db, $sql);

	while ($data = mysqli_fetch_assoc($req)){
		
		if ( md5(dlw_dec($data['email1'])) == $Email ) {
			
			//envoi des données cryptées, à décrypter dans Worpdress
			$reponse['prenom'] = $data['name'];
			$reponse['nom'] = $data['firstname'];
			$reponse['email'] = $data['email1'];
			$reponse['infos'] = $data['infos'];

			$find = true;
		
			break;
		};

	};
	
	if ($find){
		
		echo json_encode($reponse, JSON_PRETTY_PRINT);

	}else{
		
		return false;
	
	}
		
};
