<?php 
/*
 * INSTALLATION
 */

//sécurisation du dossier d'installation
define("ABSPATH", dirname(__FILE__) );

 
require_once ( ABSPATH ."/functions/script.php");

//Recherche du fichier d'installation requis, 
if (!file_exists( ABSPATH ."/admin/config.php"))
{
	require ( ABSPATH ."/admin/install.php");
	
}else{

	/*
	 * VERIFICATION BDD
	 */
	 
	require_once ( ABSPATH ."/admin/bdd.php");
	require_once ( ABSPATH ."/admin/key.php");


	if (mysqli_connect_errno())
	{
		echo "<html><head><meta charset='utf-8' /></head><body><h1>Erreur de connexion à la base de données</h1><p>Veuillez indiquer ce message d'erreur à votre webmaster :</p>";
		echo "<h2>".mysqli_connect_error()."</h2><p>".phpinfo()."</p></body></html>";
		exit;
	};
		

	session_start ();
	 

	/*
	 * AUTHENTIFICATION
	 */
	 
	// Vérification des cookies pour connexion automatique sécurisée, utilisé en première connexion si la session n'est pas active
	if (isset($_COOKIE['email']) AND !isset($_SESSION['email']))
	{  
		$sql = "select * from ".$presql."_users
				where email='".$_COOKIE['email']."'";
		$req = mysqli_query($db, $sql);
		$user = mysqli_fetch_assoc($req);
		
		//on verifie que le mot de passe du cookie est celui de la bdd et que l'utilisateur n'est pas inactif
		if(($user['passwd'] == $_COOKIE['passwd']) AND ($user['droit'] !=0))
		{
			//Enregistrement d'une session avec les données cryptées
			dlw_session($user['id_user']);
			
		// les cookies ne correspondent plus ou l'utilisateur est déclaré inactif entre deux sessions
		// aucune session n'est crée, ce qui renvoi vers la page d'authentification avec message		
		}
		
		else
		
		{
			$nok="Utilisateur désactivé";
		};
		
	//si la session est active, on verifie simplement le groupe de l'utilisateur.
	}
	else if (isset($_SESSION['id']))
	{
		$sqlverif = "select droit,id_user from ".$presql."_users where email='".$_SESSION['email']."'";
		$reqverif = mysqli_query($db, $sqlverif);
		$userverif = mysqli_fetch_assoc($reqverif);

		//les droits ont changés, deconnexion user
		if($userverif['droit'] !== $_SESSION['droit'])
		{
			dlw_deconnexion();
			if($userverif['droit'] ==0)
			{
				$avertform="inactif";
			}
			else
			{
				$avertform="droit";
			};	
		};
	};


	//si la session est toujours active, on lance la page
	if (isset($_SESSION['email']))
	{
		
		
		/*
		 * lancement du site
		 */
		 
		 
		// vérification des modules accessibles à l'utilisateurs, sera utilisé pour la navigation et les controles d'accès
		$droitmod=dlw_accesmodule();
		 
		//recupération des prefix des modules à charger
		$prefix_mod=array();
		foreach($droitmod as $val => $key){

			//récupération du nom du module accessible
			$tab_prefix_mod = explode('_', $val);
			if(!in_array($tab_prefix_mod[0],$prefix_mod)){$prefix_mod[] = $tab_prefix_mod[0];};		
			 
		};
		
		//Page d'accueil si rien n'est demandé
		if (!isset($_GET['p']))
		{
			define("DLW_PAGE", ABSPATH ."/accueil.php");
			define("DLW_SSNAV", ABSPATH ."/ssnav.php");
			define("DLW_ACCESS","ok");
			
		//Gestion de la deconnexion
		}
		else if ($_GET['p'] == "deconnexion")
		{
			//paramètres yucca si existant			
			include_once ( ABSPATH ."/admin/config.php");
			
			if (isset($_SESSION['email'])){dlw_deconnexion();$avertform="deco";};
			require ("connexion.php");
			exit;
			
		// page des paramètres du CRM et utilisateurs
		}
		else if ($_GET['p'] == "configuration")
		{	
			
			define("DLW_PAGE", ABSPATH ."/parametres.php");
			define("DLW_SSNAV", ABSPATH ."/ssnav.php");
			if($_SERVER['REQUEST_METHOD'] == 'POST'){
				
				//inclusion de la config, sauf si on la change
				if($_GET['demande'] !=="parametres"){
					include_once ( ABSPATH ."/admin/config.php");
				};
				
				dlw_get_script();
				
				include ("parametres_modif.php");
				//recalcul des droits d'accès après modification
				$droitmod=dlw_accesmodule();
				
				//recupération des prefix des modules à charger
				$prefix_mod=array();
				foreach($droitmod as $val => $key){

					//récupération du nom du module accessible
					$tab_prefix_mod = explode('_', $val);
					if(!in_array($tab_prefix_mod[0],$prefix_mod)){$prefix_mod[] = $tab_prefix_mod[0];};		
					 
				};			
				
			};
			
			// pages des paramètres accessibles à tous
			if ( ($_GET['demande']=="assistance") OR ($_GET['demande']=="parametres"))
			{
				
				define("DLW_ACCESS","ok");
				
			}
			// les autres pages sont uniquement accessibles aux administrateurs
			else
			{
				
				// verification des droits de l'utilisateur pour la page demandée, complétez la page ssnav en cas de modification
				if($_SESSION['droit']==10)
				{
					
					define("DLW_ACCESS","ok");
				
				}
				else
				{
					define("DLW_ACCESS","nok");
				};
			
			};
			
			
		// page des paramètres du CRM et utilisateurs
		}
		else if ($_GET['p'] == "mise-a-jour")
		{	

		   // Lancement de la mise à jour pour l'administrateur uniquement
		   if($_SESSION['droit']==10)
				{
					dlw_get_script();				
					include_once ( ABSPATH ."/admin/config.php");
					include('update.php');
					exit;
				
				}
				else
				{
					define("DLW_ACCESS","nok");
				};
	 

		}
		// Vérification de l'accès au module demandé (tableau générée plus haut par la fonction dlw_accesmodule)
		else if (array_search(htmlentities($_GET['p']), $droitmod) !== false)
		{
			
			$key = array_search(htmlentities($_GET['p']),$droitmod);

			define("DLW_ACCESS","ok");
			define("DLW_PAGE", ABSPATH ."/modules/".$key."/content.php");
			define("DLW_SSNAV", ABSPATH ."/modules/".$key."/nav.php");
			define("DLW_DOSSIER",htmlentities($_GET['p']));

			//tri des résultats par défaut -> code propre au module projet à rendre universel pour chaque module qui demande du tri 
			//si GET existe, on crée un coockie
			if (isset($_GET['order']))
			{
					$temps = 365*24*3600;
					setcookie ("order_proj",$_GET['order'], time() + $temps, "/");
					setcookie ("sort_proj",$_GET['sort'], time() + $temps, "/");
			}
			//sinon si le coockie existe, on tri par défaut
			else if (isset($_COOKIE['order_proj']))
			{  
				
				$_GET['order']=$_COOKIE['order_proj'];
				$_GET['sort']=$_COOKIE['sort_proj'];
			};		
					
			// inclusion de la page de traitement POST suivant formulaire avant affichage HTML
			// pagepost defini en hidden dans les formulaires
			if($_SERVER['REQUEST_METHOD'] == 'POST')
			{
				
				//Droit requis supérieur à 1 pour l'écriture
				if($_SESSION['droit']>1){
					
					//nom de la page des enregistrements POST commençant par modif_ -> à optimiser pb de sécurité
					if(isset($_POST['pagepost']))
					{	
						foreach($prefix_mod as $val){

							if ( file_exists( ABSPATH ."/functions/script_".$val.".php") ){

								include_once ( ABSPATH ."/functions/script_".$val.".php");
							};

						};	
						
						dlw_get_script();
						
						require_once ( ABSPATH ."/admin/config.php");
						include ( ABSPATH ."/modules/".$key."/".$_POST['pagepost'].".php");

					};
					
				}
				else if(isset($_POST['pagepost']))
				{
					$nok="Vous n'avez pas l'autorisation de faire des modifications";
				};
			};

		//page inexistante
		}
		else
		{
			
			define("DLW_ACCESS","nok");
			
		};

		//ouverture du site
		require_once ( ABSPATH ."/admin/config.php");
		
		
		//recupération des scripts des modules installé
		dlw_get_script();
		
		//recupération des prefix des modules à charger
		foreach($prefix_mod as $val){

			if ( file_exists( ABSPATH ."/functions/script_".$val.".php") ){

				include_once ( ABSPATH ."/functions/script_".$val.".php");
			};

		};
		
		//lancement du cron avec cUrl pour éviter le temps d'attente, ssi la variable de session n'existe pas
		if ( !isset($_SESSION['cron']) and !defined('CONFIG_cron') ) {

			$urlcron = "https://".$_SERVER['HTTP_HOST']."/cron/".CONFIG_key;
			$chcron = curl_init($urlcron);
			curl_setopt($chcron, CURLOPT_TIMEOUT, 1);
			$response = curl_exec($chcron);
			curl_close($chcron);

		};		

		//variable de session cron pour évtier de le relancer à chaque page
		$_SESSION['cron'] = "ok";
		
		require ( ABSPATH ."/site.php");

	//pas de session ni de cookie, affichage de la page de connexion
	}
	else
	{		
		//paramètres yucca si existant			
		include_once ( ABSPATH ."/admin/config.php");

		if (isset($_GET['p']))
		{
			
			//Pour les pages en accès hors connexion directe pour visiteurs, script js ou cron
			//placez les fichiers dans le dossier functions/freeaccess
			
			if(file_exists( ABSPATH ."/functions/freeaccess/".$_GET['p'].".php"))
			{
				include_once ( ABSPATH ."/functions/freeaccess/".$_GET['p'].".php");
			}
			else
			{
				header("Location:/");
				exit;
			}

		}
		else
		{
			require ("connexion.php");
			exit;
		}
	};
};
//fermeture bdd
mysqli_close($db);
exit;
