//fonctions YUCCA necessaire au fonctionnement de la structure
//fonctions spécifiques aux modules à intégrer dans un fichier script_[nom du module avant le _].js

$(document).ready(function (){

	$('.accueil').each(function(index) {
		var delay = 300 * index; // Calcule le délai en fonction de l'index
		setTimeout(function() {
			// Sélection des divs
			const div1 = $('.masonry1');
			const div2 = $('.masonry2');
			const div3 = $('.masonry3');

			// Calcul de la hauteur de chaque div
			const height1 = div1.height();
			const height2 = div2.height();
			const height3 = div3.height();

			// Comparaison des hauteurs pour trouver la plus petite
			let smallestDiv;
			if (height1 <= height2 && height1 <= height3) {
				smallestDiv = div1;
			} else if (height2 <= height1 && height2 <= height3) {
				smallestDiv = div2;
			} else {
				smallestDiv = div3;
			}
			
			 $(smallestDiv).append($(this));
			 
			 $(this).animate({
				 opacity: 1
				}, {
				 duration: 300,
				 queue: false
				}); 			 
			 
		}.bind(this), delay);

	});

	
	/*Affichage de la div d'attente*/
	$('button:not(.nowait):not(.supprimer)').on('click', function(e) {
		var $waitElement = $("#wait");
		
		// Retirer la classe "load" si elle existe déjà
		$waitElement.removeClass("load");
		
		// Attendre 5 secondes avant de vérifier si l'action normale est terminée
		setTimeout(function() {
			// Si la classe "load" n'a pas été ajoutée (c'est-à-dire que l'action normale est terminée),
			// alors ajouter la classe "load" à l'élément avec l'ID "wait"
			if (!$waitElement.hasClass("load")) {
				$waitElement.addClass("load");
			}
		}, 1500);
	});


	//scroll ancre
	jQuery("a[href*='#']:not([href='#'])").click(function() {
		if (
			location.hostname == this.hostname
			&& this.pathname.replace(/^\//,"") == location.pathname.replace(/^\//,"")
		) {
			var anchor = jQuery(this.hash);
			anchor = anchor.length ? anchor : jQuery("[name=" + this.hash.slice(1) +"]");
			if ( anchor.length ) {
				jQuery("html, body").animate( { scrollTop: anchor.offset().top - 60}, 1000,"easeOutCubic");
			}
		}
	});
	

	/*déplacement des boutons d'enregistrement dans l'espace message*/
	$('.message').append($('.actionbutton'));
   
	textareaheight();
	animatecompteur();	

	/*Onglet paramètres*/
	$('.ongletmodule').on('click',function(e){
		event.preventDefault();
		var thismodule = $(this).attr("id");
		
		//menu
		jQuery(this).addClass("clickedbouton").siblings().removeClass("clickedbouton");
		
		//div
		$(".ongletdiv").removeClass("thismodule");
		$("."+thismodule).addClass("thismodule");
		$('input[name="ongletactif"]').val(thismodule);

	});	
	
	/*affichage des mots de passe en clir sur hover*/
	$( "[type=password]" ).mouseenter(function () {
       $(this).prop('type', 'text');
     }).mouseleave(function () {
       $(this).prop('type', 'password');
     }
	);

  	//affichage des inputs compléments si l'original est coché
	$('input[name*="autoQuery"]').each(function () {
			
		var thisInput = $(this).attr('name');
		var inputComp = thisInput.slice(11);
		
		if( $('input[name*="complements_'+inputComp+'"]').length ){
			
			$('input[name="'+thisInput+'"]').addClass('toggleswitch');
			
			if ( $('input[name="'+thisInput+'"]').is(':checked') ) {
				$('input[name*="complements_'+inputComp+'"]').parent(":not(.switch)").removeClass('invisible');	
			}else{
				$('input[name*="complements_'+inputComp+'"]').parent(":not(.switch)").addClass('invisible');	
			};		
			
		}

	}); 
	
    /*affiche des complements*/
    $(".toggleswitch").click(function() {
		var inputOri = $(this).attr('name').slice(11);
		$('input[name*="_complements_'+inputOri+'"]').parent(":not(.switch)").toggleClass( "invisible" );
    });
    
    /*highlight des inputs à cocher*/	
     $(".switch input").click(function() {
		$(this).parent().next().toggleClass( "checked" );
    }); 
    
     /*highlight de valeurs svg circle*/	
	$('svg.statcircle circle, svg.statcircle text').hover(
		 function () {
			var high = $(this).attr('data-name');
			$('[data-name="'+high+'"]').toggleClass("highlight");
			},
		 function () {
			var high = $(this).attr('data-name');
			$('[data-name="'+high+'"]').toggleClass("highlight");
			}		
    );  	

    /*highlight de valeurs svg circle*/	
	$('.full').on('click',
		 function () {
			if ($(event.target).closest('circle, text').length) {
				// If it does, do nothing
				return;
			}
			 
			$(this).closest('.row').find('.full').parent().toggleClass('lowwidth');
			$(this).toggleClass('statfull').parent().toggleClass('fullwidth');
			
		}		
    ); 
    
    //confirmation de suppression

	$(".actionbutton .supprimer,.confirm").on('click', function() {
		event.preventDefault();
		var textDiv = $(this).attr("title").toUpperCase();
		var clonedDiv = $(this).clone();
		clonedDiv.removeClass("border-left", "border-right");
		
		$("#wait").addClass("load").find('.lds-ellipsis').html(clonedDiv);
		$("#wait").addClass("load").find('p').text(textDiv+" ?");
	})
	 
});

function unwait(){
	$("#wait").removeClass("load").find('.lds-ellipsis').html('<div></div><div></div><div></div><div></div>');
	$("#wait").find('p').text("VEUILLEZ PATIENTER");
};	

//hauteur automatique textarea
function textareaheight() {
    // Update textarea
    jQuery.each(jQuery('textarea'), function() {
        var resizeTextarea = function(el) {
            // Temporarily disable scrollHeight to prevent scroll
            var scrollHeight = el.scrollHeight;
            el.style.height = 'auto';
            el.style.height = scrollHeight + 'px';
        };
        resizeTextarea(this);
        jQuery(this).on('input', function() { resizeTextarea(this); });
    });
};

/*compteur*/
function animatecompteur() {
    jQuery('svg.number .statvalue').each(function () {
		var final = jQuery(this).text();
        jQuery(this).prop('Counter', 0).animate({
            Counter: final
        }, {
            easing: 'easeOutQuad',
            duration: 2000,
            step: function (now) {
                if (final % 1 === 0) {
                    // If the number is an integer, increment it by 1
					jQuery(this).text(Math.ceil(now));
                } else {
                    // If the number is not an integer, format it with two decimal places
                    jQuery(this).text(parseFloat(now).toFixed(2));
                }
            }
        });
    });
};
