//fonctions YUCCA necessaire au fonctionnement de la structure
//fonctions spécifiques aux modules à intégrer dans un fichier script_[nom du module avant le _].js

$(document).ready(function (){
	
	//détection de changement
	let hasChanges = false;

	// Détecter les modifications dans les inputs
	$('input').on('input', function () {
		hasChanges = true;
	});
	
    $('.enregistrer').on('click', function () {
		hasChanges = false; // Réinitialiser la détection des modifications
	});
	
	if( $('.enregistrer').length ){
	// Avertir avant de quitter la page si des modifications ont été faites
		$(window).on('beforeunload', function (e) {
			if (hasChanges) {
				const message = "Vous avez des modifications non enregistrées. Êtes-vous sûr de vouloir quitter ?";
				e.preventDefault();
				e.returnValue = message; // Pour certains navigateurs (legacy)
				return message; // Pour les navigateurs modernes
			}
		});
	};
	
	//organisation du tdb
	tableauDeBord();

	/*Affichage de la div d'attente*/
	$('button:not(.nowait):not(.supprimer)').on('click', function(e) {
		var $waitElement = $("#wait");
		
		// Retirer la classe "load" si elle existe déjà
		$waitElement.removeClass("load");
		
		// Attendre 5 secondes avant de vérifier si l'action normale est terminée
		setTimeout(function() {
			// Si la classe "load" n'a pas été ajoutée (c'est-à-dire que l'action normale est terminée),
			// alors ajouter la classe "load" à l'élément avec l'ID "wait"
			if (!$waitElement.hasClass("load")) {
				$waitElement.addClass("load");
			}
		}, 1500);
	});

	//scroll ancre
	jQuery("a[href*='#']:not([href='#'])").click(function() {
		if (
			location.hostname == this.hostname
			&& this.pathname.replace(/^\//,"") == location.pathname.replace(/^\//,"")
		) {
			var anchor = jQuery(this.hash);
			anchor = anchor.length ? anchor : jQuery("[name=" + this.hash.slice(1) +"]");
			if ( anchor.length ) {
				jQuery("html, body").animate( { scrollTop: anchor.offset().top - 60}, 1000,"easeOutCubic");
			}
		}
	});
	

	/*déplacement des boutons d'enregistrement dans l'espace message*/
	$('.message').append($('.actionbutton'));
   
	textareaheight();
	animatecompteur();	

	/*Onglet paramètres*/
	$('.ongletmodule').on('click',function(e){
		event.preventDefault();
		var thismodule = $(this).attr("id");
		
		//menu
		jQuery(this).addClass("clickedbouton").siblings().removeClass("clickedbouton");
		
		//div
		$(".ongletdiv").removeClass("thismodule");
		$("."+thismodule).addClass("thismodule");
		$('input[name="ongletactif"]').val(thismodule);

	});	
	
	/*affichage des mots de passe en clir sur hover*/
	$( "[type=password]" ).mouseenter(function () {
       $(this).prop('type', 'text');
     }).mouseleave(function () {
       $(this).prop('type', 'password');
     }
	);

  	//affichage des inputs compléments si l'original est coché
	$('input[name*="autoQuery"]').each(function () {
			
		var thisInput = $(this).attr('name');
		var inputComp = thisInput.slice(11);
		
		if( $('input[name*="complements_'+inputComp+'"]').length ){
			
			$('input[name="'+thisInput+'"]').addClass('toggleswitch');
			
			if ( $('input[name="'+thisInput+'"]').is(':checked') ) {
				$('input[name*="complements_'+inputComp+'"]').parent(":not(.switch)").removeClass('invisible');	
			}else{
				$('input[name*="complements_'+inputComp+'"]').parent(":not(.switch)").addClass('invisible');	
			};		
			
		}

	}); 
	
    /*affiche des complements*/
    $(".toggleswitch").click(function() {
		var inputOri = $(this).attr('name').slice(11);
		$('input[name*="_complements_'+inputOri+'"]').parent(":not(.switch)").toggleClass( "invisible" );
    });
    
    /*highlight des inputs à cocher*/	
     $(".switch input").click(function() {
		$(this).parent().next().toggleClass( "checked" );
    }); 
    
     /*highlight de valeurs svg circle*/	
	$('svg.statcircle circle, svg.statcircle text, svg.statgraph rect').hover(
		 function () {
			var high = $(this).attr('data-name');
			$('[data-name="'+high+'"]').toggleClass("highlight");
			},
		 function () {
			var high = $(this).attr('data-name');
			$('[data-name="'+high+'"]').toggleClass("highlight");
			}		
    );  	

    /*highlight de valeurs svg circle*/	
	$('.full').on('click',
		 function () {
			if ($(event.target).closest('circle, text').length) {
				// If it does, do nothing
				return;
			}
			 
			$(this).closest('.row').find('.full').parent().toggleClass('lowwidth');
			$(this).toggleClass('statfull').parent().toggleClass('fullwidth');
			
		}		
    ); 
    
    //confirmation de suppression
	$(".actionbutton .supprimer,.confirm").on('click', function() {
		event.preventDefault();
		var textDiv = $(this).attr("title").toUpperCase();
		var clonedDiv = $(this).clone();
		clonedDiv.removeClass("border-left", "border-right");
		
		$("#wait").addClass("load").find('.lds-ellipsis').html(clonedDiv);
		$("#wait").addClass("load").find('p').text(textDiv+" ?");
	});
	
	//affichage photo upload
	$('input[type="file"]').on('change', function(event) {
		  // Supprimer la div existante contenant l'image
			$(this).siblings('img').remove();
        // Ajouter une nouvelle div avec l'image sélectionnée
        $(this).parent().prepend(`<i class="imgupload logopro fa-solid fa-download"></i>`);
	});
	
	let isDragging = false; // Variable pour détecter un drag

	// Activer le sortable avec gestion du drag
	$(".sortableAcc").each(function () {
		$(this).sortable({
			items: '.accueil', // Les éléments déplaçables
			connectWith: ".sortableAcc", // Permet de connecter les colonnes
			opacity: 0.6, // Opacité pendant le drag
			placeholder: "sortable-placeholder", // Classe pour la zone où l'élément est en train d'être déplacé
			forcePlaceholderSize: true, // Forcer l'affichage de la placeholder dans les colonnes vides
			start: function (event, ui) {
				isDragging = true; // Activer le flag "dragging"
				ui.item.addClass("dragging"); // Ajouter la classe 'dragging' à l'élément en cours de déplacement
			},
			over: function (event, ui) {
				$(".ssmasonry").addClass("sortable-over"); // Ajouter une classe à la colonne survolée
			},
			stop: function (event, ui) {
				ui.item.removeClass("dragging"); // Retirer la classe 'dragging' après le drag
				$(".ssmasonry").removeClass("sortable-over"); // Retirer la classe lorsqu'on quitte la colonne
				setTimeout(() => isDragging = false, 20); // Désactiver le flag "dragging" après 200ms
				saveOrderToServer(); // Sauvegarder l'ordre après le déplacement
			}
		}).disableSelection(); // Désactiver la sélection de texte pendant le drag
	});


	// Gestion du clic sur .head
	$(".head").on('click', function(event) {
		event.preventDefault();

		// Vérifier si on est en train de dragger ou juste après un drag
		if (!isDragging) {
			$(this).parent().toggleClass('mini');

			// Appeler la fonction pour enregistrer l'ordre après réduction
		
		}
		saveOrderToServer();
	});
	 
});

function unwait(){
	$("#wait").removeClass("load").find('.lds-ellipsis').html('<div></div><div></div><div></div><div></div>');
	$("#wait").find('p').text("VEUILLEZ PATIENTER");
};	

//hauteur automatique textarea
function textareaheight() {
    // Update textarea
    jQuery.each(jQuery('textarea'), function() {
        var resizeTextarea = function(el) {
            // Temporarily disable scrollHeight to prevent scroll
            var scrollHeight = el.scrollHeight;
            el.style.height = 'auto';
            el.style.height = scrollHeight + 'px';
        };
        resizeTextarea(this);

		const charCountDiv = $('<div>').addClass('char-count').text($(this).val().length + ' c.');
		// Ajouter la div juste après le textarea
		$(this).after(charCountDiv);
		
        jQuery(this).on('input', function() {
			resizeTextarea(this);
			charCountDiv.text($(this).val().length + ' c.');
		});
    });
};


/*compteur*/
function animatecompteur() {
    jQuery('svg.number .statvalue').each(function () {
		var final = jQuery(this).text();
        jQuery(this).prop('Counter', 0).animate({
            Counter: final
        }, {
            easing: 'easeOutQuad',
            duration: 2000,
            step: function (now) {
                if (final % 1 === 0) {
                    // If the number is an integer, increment it by 1
					jQuery(this).text(Math.ceil(now));
                } else {
                    // If the number is not an integer, format it with two decimal places
                    jQuery(this).text(parseFloat(now).toFixed(2));
                }
            }
        });
    });
};

// Fonction principale du tableau de bord
function tableauDeBord() {
    // 1. Charger les données JSON depuis la div contenant le JSON
    var orderAccData = $('#orderAccData').text(); // Récupère la chaîne JSON
    try {
        var orderAcc = JSON.parse(orderAccData); // Convertit la chaîne en objet JavaScript

        // 2. Trier les éléments selon l'ordre du JSON
        $.each(orderAcc, function (columnId, items) {
            var column = $('#' + columnId); // Sélectionner la colonne par son ID

            $.each(items, function (index, item) {
                var itemId = item.id; // ID de l'élément
                var itemElement = $('#' + itemId + '.accueil'); // Vérifie que l'élément existe

                if (itemElement.length) {
                    // Ajouter la classe 'mini' si elle existe dans l'objet JSON
                    if (item.mini === 'mini') {
                        itemElement.addClass('mini');
                    }

                    // Masquer l'élément avant de le déplacer
                    itemElement.css('opacity', 0);
                    column.append(itemElement); // Déplacer dans la colonne
                    itemElement.stop(true, true).animate({ opacity: 1 }, 300); // Animation d'apparition
                }
            });
        });

    } catch (error) {
        console.error("Erreur lors du parsing du JSON : ", error);
    }

    // 3. Trier les éléments restants dans .invisible
    $('.invisible .accueil').each(function (index) {
        var delay = 300 * index; // Délai d'animation basé sur l'index

        setTimeout(function () {
            // Sélection des colonnes
            const div1 = $('#masonry1');
            const div2 = $('#masonry2');
            const div3 = $('#masonry3');

            // Calcul des hauteurs des colonnes
            const height1 = div1.height();
            const height2 = div2.height();
            const height3 = div3.height();

            // Trouver la colonne la plus courte
            let smallestDiv;
            if (height1 <= height2 && height1 <= height3) {
                smallestDiv = div1;
            } else if (height2 <= height1 && height2 <= height3) {
                smallestDiv = div2;
            } else {
                smallestDiv = div3;
            }

            // Déplacer l'élément dans la colonne la plus courte
            $(smallestDiv).append($(this));

            // Animation d'apparition
            $(this).animate(
                { opacity: 1 },
                {
                    duration: 300,
                    queue: false,
                }
            );
        }.bind(this), delay); // Utiliser bind pour garder le contexte correct
    });
}

function saveOrderToServer() {
    var order = {};

    // Récupérer l'ordre des éléments dans chaque colonne
    $(".sortableAcc").each(function() {
        var columnId = $(this).attr('id'); // ID de la colonne (par exemple: masonry1, masonry2, ...)
        order[columnId] = []; // Initialisation de l'array pour cette colonne

        // Parcourir les éléments dans la colonne actuelle
        $(this).children(".accueil").each(function() {
            var itemId = $(this).attr('id'); // ID de l'élément
            var miniClass = $(this).hasClass('mini') ? 'mini' : ''; // Vérifier si la classe 'mini' existe

            // Ajouter les données de l'élément à l'ordre
            order[columnId].push({
                id: itemId,
                mini: miniClass
            });
        });
    });

    // Envoyer l'ordre au serveur via AJAX pour le sauvegarder en JSON dans la base de données
    $.ajax({
        url: 'functions/freeaccess/OrderAcc.php', // L'URL de la page PHP où les données seront envoyées
        method: 'POST',
        data: {
            action: 'save_order',  // Action pour indiquer qu'on veut sauvegarder l'ordre
            order: JSON.stringify(order)  // Convertir l'objet en JSON
        },
        success: function(response) {
            console.log("Ordre sauvegardé avec succès :", response);
        },
        error: function(xhr, status, error) {
            console.error("Erreur lors de la sauvegarde de l'ordre :", error);
        }
    });
}

