<?php
/*
 * Modèle personnalisé PDF davelopweb
 * 
 * 
 * */

class PDF extends PDF_Rotate
{
	//En-tete
	function Header()
	{	
		global $datadoc,$docname,$nomfac,$adresse,$thisnum,$r2,$g2,$b2;
		if ($this->page == 1){
				
			$this->SetFillColor(0,0,0);
			$this->Rect(0,0,210,45,'F');
			
			if (defined('CONFIG_title')){
				$this->SetTextColor(250,250,250);
				$this->Cell(25,10,dlw_dec(CONFIG_title));
				$this->ln(0);
			};
			
			if (defined('CONFIG_adresse')){
				$this->SetFont('','',9);
				$this->Cell(25,19,utf8_decode(dlw_dec(CONFIG_adresse)));
				$this->ln(0);
			};
			
			if (defined('CONFIG_lien_wp') AND !empty(CONFIG_lien_wp)){
				$this->SetTextColor($r2,$g2,$b2);
				$this->SetFont('','U',10); 				
				$this->Cell(25,36,dlw_dec(CONFIG_lien_wp),0,0,'L',false,dlw_dec(CONFIG_lien_wp));
				$this->ln(0);				
			};
			
			$this->SetTextColor(250,250,250);
			$this->SetFont('','',9);
			
			if (defined('CONFIG_telephone')){
				$this->Cell(25,44,utf8_decode(dlw_dec(CONFIG_telephone)));
				$this->ln(0);
			};
			
			if (defined('CONFIG_emailrep')){
				$this->Cell(25,51,dlw_dec(CONFIG_emailrep));
				$this->ln(0);
			};
			
			$this->SetTextColor(0,0,0);
			$this->SetFont('','',12); 	

			
			$this->Image( ABSPATH .'/img/'.get_logo(''),150,15,-250);
			
		}else{
			$this->SetFillColor(0,0,0);
			$this->Rect(0,0,210,30,'F');
			$this->Image( ABSPATH .'/img/'.get_logo(''),182,15,-820);	
			$this->SetFont('','',8);    
			$this->SetTextColor(250,250,250);
			$this->Cell(0,10,utf8_decode($docname.' ÉLECTRONIQUE N° '.$thisnum.', émise le '.$_POST['date_fac']),0);$this->ln(4);
			$this->Cell(0,10,utf8_decode('Client : '.$nomfac.$adresse),0);$this->ln(0);	
			$this->SetFillColor(0,0,0);
			$this->SetY(40);		
		};
		
		$this->SetFont('','',100);
		$this->SetTextColor(252,252,252);
		
		switch ($datadoc['type_reglement']) { 
			//watermark relance     	        	   	    
			case "non":
				$this->RotatedText(75,235,'DUPLICATA',60);
			break;
			case "ann":
				$this->RotatedText(75,235,'ANNULE(E)',60);
			break;					
			//watermark acquitée
			case "che":
			case "vir":
			case "esp":
				$this->RotatedText(75,235,'ACQUITTEE',60);
			break;	
			default:  
				$this->RotatedText(75,235,'BROUILLON',60);
			break;  	    
		};		
		
	}

	//Pied de page
	function Footer()
	{	
		global $docname,$r2,$g2,$b2;
		
		$this->SetFillColor(0,0,0);
		$this->Rect(0,270,210,30,'F');
		$this->SetTextColor(250,250,250);
		$this->SetY(275);
		$this->SetFont('','',9);$this->SetTextColor($r2,$g2,$b2);
		if (defined('CONFIG_footer1')){
	
			$footer1 = yucca_decode_pdf(dlw_dec(CONFIG_footer1));
			$this->Cell(0,8,$footer1,0,0,'L',false);$this->ln(2);
			
		};
		$this->SetTextColor(0,0,0);		
		if (defined('CONFIG_footer2')){
			
			$footer2 = yucca_decode_pdf(dlw_dec(CONFIG_footer2));
			$this->Cell(0,13,$footer2,0,0,'L',false);$this->ln(0);
			
		};
		if (defined('CONFIG_footer3')){
			
			$footer3 = yucca_decode_pdf(dlw_dec(CONFIG_footer3));
			$this->Cell(0,20,$footer3,0,0,'L',false);$this->ln(0);
			
		};
		
		$this->SetFont('','',5);
		$this->SetTextColor($r2,$g2,$b2);		
		$this->Cell(0,30,utf8_decode(stripslashes('Document électronique généré par YUCCA, CRM pour indépendant, association et TPE - https://yucca-crm.fr')),0,0,'C',false);$this->ln(0);
		
		$this->SetTextColor(250,250,250);
		$this->Cell(0,26,$this->PageNo().'/{nb}',0,0,'R');$this->ln(0);
	}
}

$pdf = new PDF();
$pdf->AliasNbPages();
$pdf->AddFont('Opensans','','OpenSans.php');
$pdf->SetFont('Opensans','',10);     
$pdf->SetMargins(10,10);
$pdf->SetLineWidth(0.1);
$pdf->AddPage();

// titre et numéro de facture
$pdf->ln(0);
$pdf->SetFont('','',15);
$pdf->SetTextColor(0,0,0);
$pdf->Cell(49,100,utf8_decode($docname.' ÉLECTRONIQUE N° '.$thisnum));


// tableau entete
$pdf->ln(0);
$pdf->SetY(65);
$pdf->SetFont('','',10);
$pdf->SetDrawColor(0,0,0);
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(250,250,250);
$pdf->Col=2;
$pdf->Cell(45,8,utf8_decode('CLIENT'),1,0,'L',true);

$pdf->SetDrawColor(250,250,250);
$pdf->SetFillColor(250,250,250);
$pdf->SetTextColor(0,0,0);
$pdf->Cell(0,8,utf8_decode($nomfac.$adresse."hhhfg"),1,0,'L');
$pdf->ln(0);
$pdf->SetY(73);
$pdf->Cell(45,8,utf8_decode('DATE D\'EMISSION'),1,0,'L',true);
$mois = array(1 =>'Janvier','Février','Mars','Avril','Mai','Juin','Juillet','Août','Septembre','Octobre','Novembre','Décembre');  	   	    
$date_fac = explode("-", $_POST['date_fac']);
$datefac=$date_fac[2]." ".$mois[( intval($date_fac[1]) + 0 )]." ".$date_fac[0];
$pdf->Cell(0,8,utf8_decode($datefac),1,0,'L');
$pdf->ln(0);
$pdf->ln(0);
$pdf->SetY(81);
$pdf->SetDrawColor(0,0,0);
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(250,250,250);
$pdf->Cell(45,8,utf8_decode($dateinfo.' D\'EXECUTION'),1,0,'L',true);
$pdf->SetTextColor(0,0,0);

// indication du mois seulement si devis
if ($_GET['demande']=="facture"){
	$date_proj = explode("/", $_POST['date_proj']);
	$dateproj=$date_proj[2]." ".$mois[($date_proj[1]+0)]." ".$date_proj[0];
}else{
	$dateproj = $_POST['delai_proj'];
};
$pdf->SetDrawColor(250,250,250);
$pdf->SetFillColor(250,250,250);
$pdf->SetTextColor(0,0,0);
$pdf->Cell(0,8,utf8_decode($dateproj),1,0,'L');


// Référence dossier
$pdf->ln(0);
$pdf->SetY(89);
$pdf->SetFont('','',10);$pdf->SetTextColor($r2,$g2,$b2);
$pdf->Cell(0,8,utf8_decode('N/REF : '.$_POST['resume']),0,0,'L',false);


// prestations
$pdf->SetTextColor(0,0,0);
$pdf->ln(0);
$pdf->SetY(97);
$pdf->Col=5;
$pdf->SetFont('','',10);
$pdf->SetDrawColor(0,0,0);
$pdf->SetFillColor(0,0,0);
$pdf->SetTextColor(250,250,250);
$pdf->Cell(116,8,utf8_decode('DESIGNATION'),1,0,'L',true);
$pdf->Cell(25,8,utf8_decode('TARIF(U/HT)'),1,0,'C',true);
$pdf->Cell(12,8,utf8_decode('QTE'),1,0,'C',true);
$pdf->Cell(12,8,utf8_decode('TVA'),1,0,'C',true);
$pdf->Cell(0,8,'TARIF(TTC)',1,0,'C',true);
$pdf->Col=5;
$pdf->SetFont('','',10);

// generation des prestations
$pdf->SetY(107);
$Y=107;

$tvapdfligne = 0;
$totalpdfht = 0;
$totalpdfttc = 0;
$tarif20 = 0;
$tarif10 = 0;
$tarif55 = 0;
$tarif21 = 0;


$pdf->SetDrawColor(250,250,250);
$pdf->SetFillColor(250,250,250);
$pdf->SetTextColor(0,0,0);

foreach($_POST['ligne'] as $ligne) {
	$pdf->SetFont('','',10);

	$totalpdfligneht=( floatval($ligne['tarif']) * floatval($ligne['taux']));	
	$tvapdfligne=($totalpdfligneht * floatval($ligne['tva']) /100);
	$totalpdflignettc=$totalpdfligneht+$tvapdfligne;
	$totalpdfht+=$totalpdfligneht;
	$totalpdfttc+=$totalpdflignettc;

	switch ($ligne['tva']) {   
	    case "20":$tarif20+=$tvapdfligne;break;
	    case "10":$tarif10+=$tvapdfligne;break;
	    case "5.5":$tarif55+=$tvapdfligne;break;
	    case "2.1":$tarif21+=$tvapdfligne;break;   
	};

	$pdf->SetXY(126,$Y);
	$pdf->MultiCell(25,5,utf8_decode($ligne['tarif']).chr(128),0,'C',false);	
	$pdf->SetXY(151,$Y);
	$pdf->MultiCell(12,5,utf8_decode($ligne['taux']),0,'C',false);	
	$pdf->SetXY(163,$Y);
	$pdf->MultiCell(12,5,utf8_decode($ligne['tva']).'%',0,'C',false);
	$pdf->SetXY(175,$Y);
	$pdf->MultiCell(0,5,utf8_decode($totalpdflignettc).chr(128),0,'C',false);	
	$pdf->SetXY(10,$Y);
	
	//police description
	$pdf->SetFont('','',10);
	
	$decode_description = yucca_decode_pdf($ligne['description']);
	$pdf->MultiCell(116,3,$decode_description,0,'L',false); 
		
	//saut de page
    if ($Y > 235){
		
		$pdf->AddPage();
		$H = 30;
	
	}else{
		
		$H = $pdf->GetY();
		
	};
	
	$pdf->ln(0);
	
	//ligne horizontale
	$pdf->Line(10, $H+2, 200, $H+2);
	$Y=$H+4;
}			




//total
$pdf->SetY($H+2);
$pdf->Col=3;

$pdf->Cell(141,8,'',0,0,'C',false);
$pdf->SetTextColor(250,250,250);
$pdf->SetFillColor(0,0,0);
$pdf->SetFont('','',10);
$pdf->Cell(24,8,'TOTAL HT',1,0,'C',true);
$pdf->SetTextColor($r2,$g2,$b2);
$pdf->Cell(0,8,$totalpdfht.chr(128),1,0,'C',false);
$pdf->ln(0);
$H = $pdf->GetY();
$pdf->SetTextColor(0,0,0);

$pdf->SetFont('','',8);

// affichage des TVA
if( $tarif20 !==0 ){
	$pdf->SetY($H+8);
	$pdf->Col=3;
	$pdf->SetFont('','',10);
	$pdf->Cell(141,8,'',0,0,'C',false);
	$pdf->Cell(24,8,'TVA 20%',1,0,'C',true);
	$pdf->Cell(0,8,$tarif20.chr(128),1,0,'C',false);
	$pdf->ln(0);	
	$H = $pdf->GetY();
	};
if($tarif10 !==0){
	$pdf->SetY($H+8);
	$pdf->Col=3;
	$pdf->SetFont('','',10);
	$pdf->Cell(141,8,'',0,0,'C',false);
	$pdf->Cell(24,8,'TVA 10%',1,0,'C',true);
	$pdf->Cell(0,8,$tarif10.chr(128),1,0,'C',false);
	$pdf->ln(0);	
	$H = $pdf->GetY();
	};	
if($tarif55 !==0){
	$pdf->SetY($H+8);
	$pdf->Col=3;
	$pdf->SetFont('','',10);
	$pdf->Cell(141,8,'',0,0,'C',false);
	$pdf->Cell(24,8,'TVA 5.5%',1,0,'C',true);
	$pdf->Cell(0,8,$tarif55.chr(128),1,0,'C',false);
	$pdf->ln(0);	
	$H = $pdf->GetY();
	};	
if($tarif21 !==0){
	$pdf->SetY($H+8);
	$pdf->Col=3;
	$pdf->SetFont('','',10);
	$pdf->Cell(141,8,'',0,0,'C',false);
	$pdf->Cell(24,8,'TVA 2.1%',1,0,'C',true);
	$pdf->Cell(0,8,$tarif21.chr(128),1,0,'C',false);
	$pdf->ln(0);	
	$H = $pdf->GetY();
};
	

$pdf->SetY($H+8);
$pdf->Col=3;
$pdf->SetFont('','',10);
$pdf->Cell(141,8,'',0,0,'C',false);
$pdf->SetTextColor(250,250,250);
$pdf->SetFillColor(0,0,0);
$pdf->SetFont('','',9);
$pdf->Cell(24,8,'TOTAL TTC',1,0,'C',true);
$pdf->SetFont('','',10);
$pdf->SetTextColor($r2,$g2,$b2);
$pdf->Cell(0,8,$totalpdfttc.chr(128),1,0,'C',false);
$pdf->ln(0);
$pdf->SetTextColor(0,0,0);

// mentions bas de page
switch ($_GET['demande']) {      	        	   	    
	    case "facture":
			$pdf->SetY(230);
			$pdf->Col=1;
			$pdf->SetFont('','',10);
			$pdf->Cell(0,8,utf8_decode('MODALITÉ DE PAIEMENT'),0,0,'L',false);$pdf->ln(0);
			$pdf->Col=3;
			$pdf->Cell(3,18,'',0,0,'L',false);
			$pdf->Cell(15,18,utf8_decode('Chèque >'),0,0,'L',false);
			$pdf->SetTextColor($r2,$g2,$b2);
			
			if (defined('CONFIG_emailrep')){
				$pdf->Cell(0,18,utf8_decode('À l\'ordre de '.stripslashes(dlw_dec(CONFIG_title))),0,0,'L',false);$pdf->ln(0);
			};
			
			$pdf->SetTextColor(0,0,0);
			$pdf->Cell(3,27,'',0,0,'L',false);
			$pdf->Cell(17,27,utf8_decode('Virement >'),0,0,'L',false);
			$pdf->SetTextColor($r2,$g2,$b2);
			$pdf->Cell(0,27,utf8_decode('RIB page 2/2'),0,0,'L',false);$pdf->ln(0);
			$pdf->SetTextColor(0,0,0);
			$pdf->Cell(3,36,'',0,0,'L',false);
			$pdf->SetTextColor(0,0,0);
			$pdf->SetFont('','',8);
			$pdf->SetY(250);
						
			if (defined('CONFIG_mentions_devis')){
				
				$mentions = yucca_decode_pdf( dlw_dec(CONFIG_mentions_devis) );
				$pdf->MultiCell(0,4,$mentions,0,'J',false);
				
			};
	    break;
	    
	    case "devis":
			$pdf->SetY(255);
			$pdf->Col=1;
			$pdf->SetTextColor(0,0,0);$pdf->SetFont('','',8);
			
			if (defined('CONFIG_val_devis')){	
				$pdf->MultiCell(0,4,utf8_decode('Validité du devis : '.stripslashes(dlw_dec(CONFIG_val_devis))),0,'J',false);
			};	  
			break;    	    
};

//vérification des données RIB
if (

		defined('CONFIG_iban')
	AND defined('CONFIG_bic')
	AND defined('CONFIG_codebanque')
	AND defined('CONFIG_codeagence')
	AND defined('CONFIG_numerocompte')
	AND defined('CONFIG_clerib')
	AND defined('CONFIG_domiciliation')

){
	
	//dernière page RIB
	$pdf->AddPage();
	$pdf->SetFont('','',12);
	$pdf->SetTextColor(0,0,0);
	$pdf->Cell(0,0,utf8_decode('Relevé d\'identité bancaire - '.dlw_dec(CONFIG_title)),0,0,'L',false);$pdf->ln(6);
	$pdf->Cell(0,0,utf8_decode(dlw_dec(CONFIG_adresse)),0,0,'L',false);$pdf->ln(0);

	$pdf->SetY(50);
	$pdf->SetDrawColor(250,250,250);
	$pdf->SetFillColor(250,250,250);
	$pdf->Col=1;
	$pdf->SetFont('','',8);$pdf->SetTextColor(0,0,0);
	$pdf->Cell(100,8,utf8_decode('IBAN'),1,0,'C',true);
	$pdf->Cell(0,8,'BIC',1,0,'C',true);
	$pdf->SetY(58);
	$pdf->Cell(100,8,utf8_decode(dlw_dec(CONFIG_iban)),1,0,'C');
	$pdf->Cell(0,8,dlw_dec(CONFIG_bic),1,0,'C');

	$pdf->SetY(66);
	$pdf->Col=1;
	$pdf->SetFont('','',8);
	$pdf->Cell(30,8,utf8_decode('Code banque'),1,0,'C',true);
	$pdf->Cell(30,8,'Code agence',1,0,'C',true);
	$pdf->Cell(40,8,utf8_decode('Numéro de compte'),1,0,'C',true);
	$pdf->Cell(20,8,utf8_decode('Clé RIB'),1,0,'C',true);
	$pdf->Cell(0,8,'Agence de domiciliation',1,0,'C',true);

	$pdf->SetY(74);
	$pdf->Cell(30,8,utf8_decode(dlw_dec(CONFIG_codebanque)),1,0,'C');
	$pdf->Cell(30,8,dlw_dec(CONFIG_codeagence),1,0,'C');
	$pdf->Cell(40,8,dlw_dec(CONFIG_numerocompte),1,0,'C');
	$pdf->Cell(20,8,dlw_dec(CONFIG_clerib),1,0,'C');
	$pdf->Cell(0,8,dlw_dec(CONFIG_domiciliation),1,0,'C');
	$pdf->Line(10, 100, 210-10, 100);
	$pdf->Image( ABSPATH .'/modules/yucca_document/img/decoupe.png',30,98,-275);
	$pdf->SetY(84);
	$pdf->Cell(0,8,'Rappel du montant total de votre facture : '.$totalpdfttc.chr(128),0,0,'R',false);
	
};
?>
