<?php
	/**
		
		La class contient les méthodes qui servent à adapter l'agenda NextCloud au tâches du CRM
	
	**/
use Sabre\DAV;

class task_in_NextCloud{
	static function addTask($titre,$dateDebut,$heureDebut,$dateFin,$heureFin,$description,$location){
		//Récupérer les données du formulaire
		date_default_timezone_set('Europe/Paris');
		$DATE = date('dmy');
		$microtime = microtime(true);
		$microseconds = sprintf("%06d", ($microtime - floor($microtime)) * 1000000);
		$HEURE = date('His'.$microseconds);
		$uid = 'yucca'. $DATE.$HEURE; 
		
		
		$nexturl='https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/dav/calendars/'.dlw_dec(CONFIG_name_cloud).'/'.dlw_dec(CONFIG_agenda_projet).'/'.$uid.'.ics';
		//Headers
		$headers = array('Content-Type: text/calendar', 'charset=utf-8'); 
		//identifiant et password pour se connecter
		$userpwd = dlw_dec(CONFIG_name_cloud).':'.dlw_dec(CONFIG_password_cloud);
		//Les 3 conditions
		if (empty($heureDebut))
		{
			$dateTimeDebut = new DateTime($dateDebut, new DateTimeZone('Europe/Paris'));
			$dateTimeFin = new DateTime($dateFin, new DateTimeZone('Europe/Paris'));
			//Formatez la date et l'heure en utilisant le format souhaité
			$datedebut = ';VALUE=DATE:'.$dateTimeDebut->format('Ymd');
			$datefin = ';VALUE=DATE:'.date('Ymd', strtotime($dateFin . ' +1 day'));
			//DTSTAMP
			$Stamp = $dateTimeDebut->format('Ymd\THis\Z');
			
		}
		elseif (empty($heureFin)) 
		{
			//Combinez la date et l'heure dans une seule chaîne
			$dateHeureDebut = $dateDebut . ' ' . $heureDebut;
			//Créez un objet DateTime en utilisant la chaîne de date et d'heure avec le fuseau horaire français
			$dateTimeDebut = new DateTime($dateHeureDebut, new DateTimeZone('Europe/Paris'));
			//Formatez la date et l'heure en utilisant le format souhaité
			$datedebut = ':'.$dateTimeDebut->format('Ymd\THis');
			//ajoute une heure de plus a la date precedent
			$datefin = ':'.date('Ymd\THis', strtotime($dateHeureDebut . ' +1 hour'));
			//DTSTAMP
			$Stamp = $dateTimeDebut->format('Ymd\THis\Z');
		}
		else
		{
			//Combinez la date et l'heure dans une seule chaîne
			$dateHeureDebut = $dateDebut . ' ' . $heureDebut;
			$dateHeureFin = $dateFin . ' ' .$heureFin;
			//Créez un objet DateTime en utilisant la chaîne de date et d'heure avec le fuseau horaire français
			$dateTimeDebut = new DateTime($dateHeureDebut, new DateTimeZone('Europe/Paris'));
			$dateTimeFin = new DateTime($dateHeureFin, new DateTimeZone('Europe/Paris'));
			//Formatez la date et l'heure en utilisant le format souhaité
			$datedebut = ':'.$dateTimeDebut->format('Ymd\THis');
			$datefin = ':'.$dateTimeFin->format('Ymd\THis');
			//DTSTAMP
			$Stamp = $dateTimeDebut->format('Ymd\THis\Z');
		}
		//ligne ics
		$body = <<<__EOD
		BEGIN:VCALENDAR
		VERSION:2.0
		BEGIN:VEVENT
		DTSTAMP:$Stamp
		DTSTART$datedebut
		DTEND$datefin
		UID:$uid
		DESCRIPTION:$description
		LOCATION:$location
		SUMMARY:$titre
		END:VEVENT
		END:VCALENDAR
		__EOD;

		$ch = curl_init($nexturl);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($ch, CURLOPT_USERPWD, $userpwd);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
		curl_setopt($ch, CURLOPT_POSTFIELDS, $body);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

		//Execute la requête
		curl_exec($ch);
		curl_close($ch);
		return $uid;
	}
	static function DeleteTask($event_id){
	
		//Récupère la fonction de l'API NextCloud
		$nexturl='https://'.dlw_dec(CONFIG_lien_cloud).'/remote.php/dav/calendars/'.dlw_dec(CONFIG_name_cloud).'/'.dlw_dec(CONFIG_agenda_projet).'/'.$event_id.'.ics';
		
		//Headers
		$headers = array('Content-Type: text/calendar', 'charset=utf-8'); 
		//identifiant et password pour se connecter
		$userpwd = dlw_dec(CONFIG_name_cloud).':'.dlw_dec(CONFIG_password_cloud);

		//Prépare la requête
		$ch = curl_init($nexturl);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($ch, CURLOPT_USERPWD, $userpwd);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

		//Execute la requête
		$response = curl_exec($ch);
	}
}