<?php 
//couleurs personalisées
if ( !empty( $_SESSION['couleur'] ) AND ( !isset($userCoul) ))
{
	list($r1, $g1, $b1) = sscanf( $_SESSION['couleur'] , "#%02x%02x%02x");
}
//couleur après enregsitrement des paramètres
else if(isset($userCoul))
{
	list($r1, $g1, $b1) = sscanf($userCoul, "#%02x%02x%02x");

}
else if ( defined('CONFIG_coul') )
{
	list($r1, $g1, $b1) = sscanf(dlw_dec(CONFIG_coul), "#%02x%02x%02x");
}
//couleur par defaut
else
{
	$r1='42';$g1='203';$b1='111';
};

//calcul du nuancier
$coul2=$r1.','.$g1.','.$b1; //couleur utilisateur
$coul4=($r1+(255-$r1)*0.3).','.($g1+(255-$g1)*0.3).','.($b1+(255-$b1)*0.3);
$coul5=($r1-25).','.($g1).','.($b1+30);
$coul6=($r1+20).','.($g1-20).','.($b1-20);
$coul7=($r1-20).','.($g1-50).','.($b1-20);

if ( $_SESSION['theme'] == 'checked' ) {
	
	$coul9=$coul1='250,250,250'; //clair	
	$coul10=$coul3='45,52,54';//foncé
	$coul8='31,31,31';//fond
	
	
}else{
	
	$coul10=$coul1='45,52,54'; //foncé
	$coul9=$coul3='250,250,250'; //Clair
	$coul8='235,236,240';//fond
	
};

?>


html {
	width: 100%;
	height: 100%;
	margin: 0;
	padding: 0;
}

body {
	height: 100%;
	width: 100%;
	top: 0;
	left: 0;
	line-height: 1.5em;
	margin: 0;
	padding: 0;
	color: rgba(<?php echo $coul1;?>, 1);
	background-color: rgba(<?php echo $coul8;?>, 1);
	box-sizing: border-box;
	-moz-box-sizing: border-box;
	/* Firefox */
}

a:not(.bouton):link,
a:not(.bouton):focus,
a:not(.bouton):active,
a:not(.bouton):visited,
a:not(.bouton):hover {
	display: inline-block;
	color: rgba(<?php echo $coul1;?>, 1);
	outline: none;
}

a:not(.bouton) {
	text-decoration: underline;
}


/*font*/

body,
textarea,
input {
	font-family: 'Open Sans', sans-serif;
	font-size: 1em;
}


/*grille css*/

.container {
	width: 100%;
	padding: 10px;
	box-sizing: border-box;
	margin: auto;
}

.container-princ {
	min-height: calc(100vh - 55px);
	max-width:1920px;
	overflow:hidden;
}

.container-princ>.access {
	padding-left: calc(4em - 10px);
}

.row {
	margin: -10px;
	position: relative;
	padding: 0em;
	display: flex;
	align-items: stretch;
	box-sizing: border-box;
	flex-wrap: wrap;
}

.baseline {
	align-items: baseline;
}

.col1 {
	width: calc(100%/12*1);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col2 {
	width: calc(100%/12*2);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col3 {
	width: calc(100%/12*3);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col4 {
	width: calc(100%/12*4);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col5 {
	width: calc(100%/12*5);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col6 {
	width: calc(100%/12*6);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col7 {
	width: calc(100%/12*7);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col8 {
	width: calc(100%/12*8);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col9 {
	width: calc(100%/12*9);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col10 {
	width: calc(100%/12*10);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col11 {
	width: calc(100%/12*11);
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.col12 {
	width: 100%;
	padding: 10px;
	box-sizing: border-box;
	position: relative;
}

.row > div
{
	transition:all 0.2s;
}
.row > div:last-of-type
{
	flex-grow:1;
}

.divacc {
	height: 100%;
	display: table;
}

.divacc .boutonbottom {
	width: 100%;
	height: 3em;
	line-height: 3em;
	display: table-row;
	vertical-align: bottom;
}

.nopadding {
	padding: 0 !important;
}

.hidefixe {
	display: none;
}

.flex {
	display: flex;
}

.jqueryname{
	display:none;
}

.table {
	display:table;
}

/*entete des tableaux*/

.legende {
	padding: 5px;
	margin: 5px 0;
}

.legende .row {
	margin-left:46px;
}

.legende.noicon .row {
	margin-left:0px;
}

.legende a{
	color:rgba(<?php echo $coul3;?>, 1) !important;
}

.legende p {
	margin: 0;
	font-size: 0.8em;
	text-transform: uppercase;
}

/*private*/

.private {
	min-height: 100vh;
	align-items: center;
	justify-content: center;
}
.comess{color:rgba(<?php echo $coul6;?>, 1);}
#firstcolor{stop-color:rgba(<?php echo $coul2;?>, 1);}
#lastcolor{stop-color:rgba(<?php echo $coul6;?>, 1);}

/*bouton*/

.bouton {
	text-align: center;
	display: inline-block !important;
	border: none;
	font-size: 1em;
	text-decoration: none;
	vertical-align: top;
	transition: all 0.3s cubic-bezier(.25, .8, .25, 1);
	margin: 0;
	box-sizing: border-box;
	-moz-box-sizing: border-box;
	min-width: 40px !important;
	min-height: 46px !important;
	padding: 11px !important;
	background-color: rgba(<?php echo $coul6;?>, 1);
	color: rgba(<?php echo $coul9?>, 1);
}
.clickedbouton{	background-color:rgba(<?php echo $coul3;?>, 1);color:rgba(<?php echo $coul1;?>, 1); }

.bouton.strong {
	font-weight: bold;
}


/*form*/

input:not([type='checkbox']),
select {
	width: 100%
}

input[type=file] {
	background-color: rgba(<?php echo $coul8;?>, 0);
	padding: 0.1em;
	border: none;
	padding: 0.7em 1em 0 1em;
	color: rgba(<?php echo $coul3;?>, 1);
	box-sizing: border-box;
}

input[type=submit] {
	background-color: rgba(<?php echo $coul8;?>, 1);
	padding: 1em;
	color: rgba(<?php echo $coul3;?>, 1);
	cursor: pointer;
	text-transform: uppercase;
	box-sizing: border-box;
}

input[type=email],
input[type=password],
input[type=text],
input[type=time],
input[type=number],
select {
	height: 46px;
	padding: 0 10px;
	background-color: rgba(<?php echo $coul3;?>, 1);
	color: rgba(<?php echo $coul1;?>, 1);
	border: none;
	box-sizing: border-box;
}

select {
	padding: 0 1em;
}

input[type=text],
input[type=date] {
	vertical-align: top;
	height: 46px;
	padding: 0 10px;
	background-color: rgba(<?php echo $coul3;?>, 1);
	color: rgba(<?php echo $coul1;?>, 1);
	border: none;
	box-sizing: border-box;
}

input[type=color] {
	padding: 0;
	border: none;
	height: 46px;
	cursor: pointer;
}


/*div for input*/

.divinput+.divinput,
input+select,
select+input,
.select:not(.invisible)+input,
input+textarea {
	margin-top: 5px;
	display: flex
}

.divinput {
	margin-top: 5px;
	display: flex;
	position: relative;
}

label.icon {
	vertical-align: top;
	width: 46px;
	background-color: rgba(<?php echo $coul2;?>, 1);
	color: rgba(<?php echo $coul9;?>, 1);
	display: inline-block;
	padding: 11px;
	box-sizing: border-box;
	text-align: center;
	height:46px;
}

label.icon.nonvalid {
	background-color: rgba(<?php echo $coul1;?>, 1);
}

label i {
	line-height: 24px !important;
}

i.alert {
   color: rgba(<?php echo $coul7;?>, 1);
}

.inputdroitutil {
    width: calc(100%/12*5 - 80px);
}

/*form select checkbox pour group*/

.groups_div {
	position: relative;
	z-index: 0;
}

.groups_check {
	display: none;
	position: absolute;
	top: -5px;
	left:4em;
	padding: 0.5em 1.5em 0.5em 0;
	background-color: rgba(<?php echo $coul2;?>, 1);
	color: rgba(<?php echo $coul8;?>, 1);
	box-shadow: 0 1px 3px rgba(<?php echo $coul1;?>,0.12), 0 1px 2px rgba(<?php echo $coul1;?>,0.24);
}

.groups_check input {
	width: 10px;
	margin-right: 10px;
}

.groups_div:hover {
	z-index: 10;
}

.groups_div:hover .groups_check,
.groups_check:hover {
	display: block;
	z-index: 10;
}

.groups_check .switch {
	position:relative;
	margin-right:1em;
}


/*listing résultat*/

.listing {
	margin: 0;
	min-height:46px;
}

.listing p,
.listing a:not(.bouton) {
	text-overflow: ellipsis;
	white-space: nowrap;
	overflow: hidden;
	width: 100%;
	margin: 0;
	padding: 0;
	display: inline;
	vertical-align:top;
}


/*couleur par défaut*/

.letter,
.listing {
	display: inline-block;
	vertical-align: top;
}

.letter {
	width: 46px;
	padding: 0.6em 0;
	color: rgba(<?php echo $coul8;?>, 1);
	background-color: rgba(<?php echo $coul4;?>, 1);
	text-align: center;
	font-weight: 700;
}

.letter.impair {
	background-color: rgba(<?php echo $coul2;?>, 1);
}

.listing {
	width: 100%;
}

.letter+.listing {
	width: calc(100% - 46px);
}


.listing .container:not([style*="display: none"])~.container {
	margin-top: 5px;
}

.listing .row > div:not(.colacces):not(.nopadding) {
	overflow: hidden;
	text-overflow: ellipsis;
	min-height: 46px;
	box-sizing:border-box;
}

.listing .row>div+div {
	border-left: 5px solid rgba(<?php echo $coul8;?>, 1);
}
.listing .row .divinput {
	margin:0;
}

.listing .row:hover .icon {
	background-color: rgba(<?php echo $coul7;?>, 1);
	transition: all 0.5s;
}

.listing .row:hover p{
	font-weight:bold;
	transition: all 0.5s;
	color: rgba(<?php echo $coul2;?>, 1);
}

.listing .row:hover input,.listing .row:hover select{
	transition: all 0.5s;
	background-color: rgba(<?php echo $coul7;?>, 1);
	color: rgba(<?php echo $coul3;?>, 1);
}

.blocklisting {
	margin: 5px 0;
}

.listing+.listing {
	border-top: 5px solid rgba(<?php echo $coul8;?>, 1);
}

.fiche,.fiche2 {
	background-color: rgba(<?php echo $coul3;?>, 1);
}

.fiche{
	display: none;
}

.searchok:not(.hide) {
	display: block;
}


/*Couleurs générales*/

h1 {
	color: rgba(<?php echo $coul2;?>, 1);
	display: inline-block;
}

h2,
h3 {
	color: rgba(<?php echo $coul2;?>, 1);
	display: inline-block;
}

h4 {
	color: rgba(<?php echo $coul1;?>, 1);
	display: inline-block;
	margin:0;
}

p {
	color: rgba(<?php echo $coul1;?>, 1);
}

p.corresp {
	color: rgba(<?php echo $coul3;?>, 1);
	font-weight: bold;
}

hr {
	border-bottom: none;
	border-top: 1px solid rgba(<?php echo $coul1;?>, 0.2);
	margin:1.5em 0;
	width:100%;
}


/*couleur 1*/

.couleur1 {
	background-color: rgba(<?php echo $coul1;?>, 1)!important;
}

.bordercouleur1 {
	border: 1px solid rgba(<?php echo $coul1;?>, 1)!important;
}

.couleur1 a {
	color: rgba(<?php echo $coul3;?>, 1);
}

.fontcouleur1 {
	color: rgba(<?php echo $coul1;?>, 1) !important;
}

.couleur1 h2 {
	color: rgba(<?php echo $coul3;?>, 1);
}

.couleur1 p {
	color: rgba(<?php echo $coul3;?>, 1);
}

.statcouleur1 .first {
	stroke: rgba(<?php echo $coul1;?>, 1);
}
.statcouleur1 text, .rectcouleur1 {
	fill: rgba(<?php echo $coul1;?>, 1);
}

/*couleur 2*/

.couleur2 {
	background-color: rgba(<?php echo $coul2;?>, 1)!important;
}

.bordercouleur2 {
	border: 1px solid rgba(<?php echo $coul1;?>, 1)!important;
}

text{position:absolute;top:0;}
.couleur2 a {
	color: rgba(<?php echo $coul3;?>, 1) !important;
}

.fontcouleur2 {
	color: rgba(<?php echo $coul2;?>, 1) !important;
}

.couleur2 h2 {
	color: rgba(<?php echo $coul8;?>, 1);
}

.couleur2 p {
	color: rgba(<?php echo $coul8;?>, 1);
}

.statcouleur2 .first {
	stroke: rgba(<?php echo $coul2;?>, 1);
}
.statcouleur2 text, .rectcouleur2{
	fill: rgba(<?php echo $coul2;?>, 1);
}

/*couleur 3*/

.couleur3 {
	background-color: rgba(<?php echo $coul3;?>, 1) !important;
}

.bordercouleur3 {
	border: 1px solid rgba(<?php echo $coul3;?>, 1) !important;
}



.couleur3 a {
	color: rgba(<?php echo $coul2;?>, 1) !important;
	;
}

.fontcouleur3 {
	color: rgba(<?php echo $coul3;?>, 1) !important;
}

.statcouleur3 .first {
	stroke: rgba(<?php echo $coul3;?>, 1);
}
.statcouleur3 text, .rectcouleur3 {
	fill: rgba(<?php echo $coul3;?>, 1);
}

/*couleur 4*/

.couleur4 {
	background-color: rgba(<?php echo $coul4;?>, 1) !important;
}

.bordercouleur4 {
	border: 1px solid rgba(<?php echo $coul4;?>, 1) !important;
}

.couleur4 a {
	color: rgba(<?php echo $coul5;?>, 1) !important;
}

.fontcouleur4 {
	color: rgba(<?php echo $coul4;?>, 1) !important;
}

.statcouleur4 .first {
	stroke: rgba(<?php echo $coul4;?>, 1);
}
.statcouleur4 text, .rectcouleur4 {
	fill: rgba(<?php echo $coul4;?>, 1);
}

/*couleur 5*/

.couleur5 {
	background-color: rgba(<?php echo $coul5;?>, 1) !important;
}

.bordercouleur5 {
	border: 1px solid rgba(<?php echo $coul5;?>, 1) !important;
}


.couleur5 a {
	color: rgba(<?php echo $coul4;?>, 1) !important;
}

.fontcouleur5 {
	color: rgba(<?php echo $coul5;?>, 1) !important;
}

.statcouleur5 .first {
	stroke: rgba(<?php echo $coul5;?>, 1);
}

.statcouleur5 text, .rectcouleur5 {
	fill: rgba(<?php echo $coul5;?>, 1);
}

/*couleur 6*/

.couleur6 {
	background-color: rgba(<?php echo $coul6;?>, 1) !important;
}

.bordercouleur6 {
	border: 1px solid rgba(<?php echo $coul6;?>, 1) !important;
}


.couleur6 a {
	color: rgba(<?php echo $coul4;?>, 1) !important;
}

.fontcouleur6 {
	color: rgba(<?php echo $coul6;?>, 1) !important;
}

.couleur6 h2 {
	color: rgba(<?php echo $coul8;?>, 1);
}

.couleur6 p {
	color: rgba(<?php echo $coul8;?>, 1);
}

.statcouleur6 .first {
	stroke: rgba(<?php echo $coul6;?>, 1);
}

.statcouleur6 text, .rectcouleur6 {
	fill: rgba(<?php echo $coul6;?>, 1);
}

/*couleur 7*/

.couleur7 {
	background-color: rgba(<?php echo $coul7;?>, 1) !important;
}

.bordercouleur7 {
	border: 1px solid rgba(<?php echo $coul7;?>, 1) !important;
}

.couleur7 a {
	color: rgba(<?php echo $coul8;?>, 1) !important;
}

.fontcouleur7 {
	color: rgba(<?php echo $coul7;?>, 1) !important;
}

.statcouleur7 .first {
	stroke: rgba(<?php echo $coul7;?>, 1);
}

.statcouleur7 text, .rectcouleur7 {
	fill: rgba(<?php echo $coul7;?>, 1);
}

/*couleur 8*/

.couleur8 {
	background-color: rgba(<?php echo $coul8;?>, 1) !important;
}

.bordercouleur8 {
	border: 1px solid rgba(<?php echo $coul8;?>, 1) !important;
}

.couleur8 a {
	color: rgba(<?php echo $coul1;?>, 1) !important;
}

.fontcouleur8 {
	color: rgba(<?php echo $coul8;?>, 1) !important;
}

.statcouleur8 .first {
	stroke: rgba(<?php echo $coul8;?>, 1);
}
.statcouleur8 text, .rectcouleur8 {
	fill: rgba(<?php echo $coul8;?>, 1);
}	

.bouton:hover {
	cursor: pointer;
	text-decoration: none;
	background-color: rgba(<?php echo $coul3;?>, 1) !important;
	color: rgba(<?php echo $coul6?>, 1) !important;
}

.bouton:hover:before {
	color: rgba(<?php echo $coul2?>, 1) !important;
}

.encart
{	background-color: rgba(<?php echo $coul3;?>, 1) !important;
	padding:20px;
	border:10px solid rgba(<?php echo $coul8;?>, 1);
}




/*nav*/

#homeyucca {
	fill: rgba(<?php echo $coul2?>, 1) !important;
	height:30px;
	width:30px;
	margin-top:10px;
	position:absolute;
	top:0;
}

.private #homeyucca {
	width: 20em;
	height: 10em;
	position:relative;
}

.imgupload.logopro {
	padding: 5em;
	margin: auto;
	max-width:100%;
	max-height: 20em;
	box-sizing:border-box;
}

.imgupload.imgaccueil {
	padding: 0;
	max-width:100%;
	margin: auto;
	max-height: 20em;

}

.divimg {
	background-color:rgba(<?php echo $coul8?>, 1);
	height:20em;
}


.imgupload~.editer {
	position: absolute;
	left: 0px;
	top: 0px;
	font-size: 0.8em;
	display: block;
	cursor: pointer
}

#logofav,
#logopro,
#imgaccueil {
	display: none;
}

nav {
	display: inline-block;
	padding: 0;
	margin-left:35px;
	font-size: 0.8em;
	box-sizing: border-box;
	overflow: hidden;
	-moz-box-sizing: border-box;
	/* Firefox */
}

nav ul {
	padding: 0;
	margin: 0;
	list-style: none;
	display: inline
}

nav li {
	padding: 0;
	margin: 0;
	list-style: none;
	display: inline-block;
}

nav a {
	transform: translateY(1.1em);
	vertical-align: top;
	box-sizing: border-box;
	display: inline-block;
	text-align: center;
	padding: 0 5px;
	text-decoration: none !important;
	width: 5.5em;
	color: rgba(<?php echo $coul1;?>, 1) !important;
	text-overflow: ellipsis;
	white-space: nowrap;
	overflow: hidden;
	
}

nav span {
	opacity: 0;
}

nav a.this,
nav a:hover {
	color: rgba(<?php echo $coul2;?>, 1) !important;
}

nav:hover a {
	transform: translateY(0.3em);
}

nav:hover span {
	opacity: 1;
	transition: all 0.2s ease-in-out
}

nav .separator {
	border-left: 1px solid rgba(<?php echo $coul1;?>, 0.5);
	height: 50px
}

nav .separator~.separator {
	border-left: 0px solid rgba(<?php echo $coul3;?>, 0.5);
	height: 50px
}


/*menu principal defaut*/

.out::before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f2f5";
	display: block;
	font-size: 2em;
}

.update::before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\e4bb";
	display: block;
	font-size: 2em;
	color:rgba(<?php echo $coul2;?>, 1);
	animation-duration: .8s;
	animation-name: clignoter;
	animation-iteration-count: infinite;
	transition: none;
}

@keyframes clignoter {
  0%   { opacity:1; }
  40%   {opacity:0; }
  100% { opacity:1; }
}


#wordpressnav::before {
	font-family: "Font Awesome 5 Brands";
	font-weight: 900;
	content: "\f19a";
	display: block;
	font-size: 2em;
}

#cloudnav::before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0c2";
	display: block;
	font-size: 2em;
}


/*Sous menu*/

#navpage {
	overflow: hidden;
	height: calc(100% - 77px);
	font-size: 0.8em;
	position: fixed;
	top: 67px;
	left: 0;
	max-width: 4em;
	z-index: 102;
	background: linear-gradient(60deg,rgba(<?php echo $coul7;?>,1),rgba(<?php echo $coul2;?>,1));
	color:rgba(<?php echo $coul3;?>,1);
	transition: max-width 0.2s ease-in-out;
}

#navpage:hover {
	box-shadow: 0px 0px 7px rgba(<?php echo $coul1;?>, 0.1);
	max-width:100% !important;
}


#navpage:not(:hover) span {
	opacity: 0;
	transition-delay:opacity 0s;
}

#navpage span{
	transition-delay: opacity 0.2s;
}

#navpage ul {
	height: 100%;
	list-style: none;
	padding: 0;
	margin: 0;
	white-space: nowrap;
	display: flex;
	flex-direction:column;
}

#navpage li a {
	width: 100%;
	padding: 1em;
	border-left: 5px solid rgba(<?php echo $coul3;?>, 0);
	text-decoration: none;
	color: rgba(<?php echo $coul3;?>, 1) !important;
}

#navpage li a:hover {
	border-left: 5px solid rgba(<?php echo $coul1;?>, 1);
	color: rgba(<?php echo $coul1;?>, 1) !important;
	background-color: rgba(<?php echo $coul3;?>, 1) !important;

}

#navpage li a:hover span {
	color: rgba(<?php echo $coul1;?>, 1) !important;

}

#navpage li a:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	padding-right: 1em;
	text-align: center;
}

#lienconfig {
	margin-top:auto;
}

#lienconfig a:before {
	content: "\f085";
}

#paramssnav a:before {
	content: "\f509";
}

#profilssnav a:before {
	content: "\f013";
}

#userssnav a:before {
	content: "\f007";
}

#accssnav a:before {
	content: "\f06e";
}

#aidessnav a:before {
	content: "\f059";
}

#versionssnav a:before {
	content: "\f05a";
}

#accesssnav a:before {
	content: "\f13e";
}

#groupessnav a:before {
	content: "\f0c0";
}

#hautdepagessnav a:before {
	content: "\f30c";
}
/*Wait*/

#wait {
	position: fixed;
	z-index: 103;
	height: 100vh;
	width: 100%;
	align-content: center;
	display: table;
	text-align: center;
	background-color: rgba(<?php echo $coul1;?>, 0.6);
	opacity: 0;
	pointer-events: none;
}

#wait p{
	color: rgba(<?php echo $coul3;?>, 1);
	font-size:1.5em;
}

#wait.load {
	opacity: 1;
	pointer-events: auto;
	-webkit-transition: .4s;
	transition: .4s;
}
#wait button {
	margin:0 2px;
}

.lds-ellipsis {
	margin-top: calc( 50vh - 4em);
	display: inline-block;
	position: relative;
	width: 100px;
	height:46px;
}

.lds-ellipsis div {
	position: absolute;
	top:23px;
	width: 15px;
	height: 15px;
	background: rgba(<?php echo $coul2;?>, 0.8);
	animation-timing-function: cubic-bezier(0, 1, 1, 0);
}

.lds-ellipsis div:nth-child(1) {
	left: 17px;
	animation: lds-ellipsis1 0.6s infinite;
}

.lds-ellipsis div:nth-child(2) {
	left: 17px;
	animation: lds-ellipsis2 0.6s infinite;
}

.lds-ellipsis div:nth-child(3) {
	left: 41px;
	animation: lds-ellipsis2 0.6s infinite;
}

.lds-ellipsis div:nth-child(4) {
	left: 65px;
	animation: lds-ellipsis3 0.6s infinite;
}

@keyframes lds-ellipsis1 {
	0% {
		transform: scale(0);
	}
	100% {
		transform: scale(1);
	}
}

@keyframes lds-ellipsis3 {
	0% {
		transform: scale(1);
	}
	100% {
		transform: scale(0);
	}
}

@keyframes lds-ellipsis2 {
	0% {
		transform: translate(0, 0);
	}
	100% {
		transform: translate(24px, 0);
	}
}


/*Boutons d'action*/

.ajouter:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f067";
}

.supprimer,.desinstaller{
	background-color: rgba(<?php echo $coul1;?>, 1);
	color: rgba(<?php echo $coul3;?>, 1);
}

.supprimer:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f2ed";
}

.desinstaller:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f093";
}


.enregistrer:before{
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f04c";
}

.enregistrer:not(.onload):before,.modifier:before{
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0c7";
}

.enregistrer.onload {
	background-color: rgba(<?php echo $coul7;?>, 1);
	color: rgba(<?php echo $coul3;?>, 1);
}

.telecharger:before{
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f019";
}

.consulter {
	text-decoration: none !important;
	font-size: 2em;
	position: absolute;
	top: 20px;
	right: 20px;
	z-index: 2;
}

.consulter:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0ac";
}

.editer:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f304";
}

.rechercher:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f002";
}

.rechercher_ou:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f010";
}

.rechercher_et:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f00e";
}

.annuler {
	background-color:rgba(<?php  echo $coul3;?>,1);
	color:rgba(<?php  echo $coul1;?>,1);
}

.annuler:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f00d";
}

.file:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f56e";
}

.pref:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f5aa";
	padding-right: 0.5em
}

.installer:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f019";
}

.visualiser:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f06e";
}

.mail:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0e0";
}

.cloud:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0c2";
}

.more:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f06e";
}

.more.closed:before {
	content: "\f070";
}

.precedent,.suivant{background-color:rgba(<?php  echo $coul4;?>,1);}
.noentry{background-color:rgba(<?php  echo $coul1;?>,1);}

.precedent:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0dd";
}

.suivant:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f0de";
}

.noentry:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f05e";
}

/*page accueil*/
.masonry1,.masonry2,.masonry3{width:calc(100% / 12 * 4);display:inline-block;vertical-align:top;box-sizing:border-box;}
.masonry1{padding-right:12px;}
.masonry2{padding:0 6px 0 6px;}
.masonry3{padding-left:12px;}

.accueil:before{
	position:absolute;
	left:calc( 50% - 1em );
	z-index:100;
	top:85px;
	text-align:center;
	background:rgba(<?php echo $coul2;?>, 1);
	color:rgba(<?php echo $coul3;?>, 1);
	height:2em;width:2em;
	line-height:2em;
	box-sizing: border-box;

}

.accueil {
	margin-bottom:16px;
	padding:20px;
	page-break-inside: avoid;
	break-inside: avoid-column;
	display: inline-block;
	background-color: rgba(<?php echo $coul3;?>, 1);
	width: 100%;
	box-sizing: border-box;
	overflow:hidden;
	position:relative;
	opacity:0;
	transition:opacity 0.2s;
}

.accueil.visible{opacity:1;transition:opacity 0.2s;}

.accueil a.head{
	display:block;
}

.accueil h2 {
	color: rgba(<?php echo $coul2;?>, 1);
	width:calc(100% - 12px);
	margin:6px 6px 40px 6px;
	padding:12px 0px 40px 0px;
	box-sizing: border-box;
	font-size:1.2em;
	text-transform:uppercase;
	text-align:center;
	position:relative;
}

.accueil h2:before{
	content:"";
	height:50px;
	width:60%;
	position:absolute;
	top:-40px;
	left:20%;
	background-color:rgba(<?php echo $coul8;?>, 1);
	z-index:9;
}

.accueil:hover h2{
	color: rgba(<?php echo $coul1;?>, 1);transition: all 0.5s;
}

.accueil h2:hover:after{
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f061";
	margin-left:0.5em;
}

.accueil h3 {
	color: rgba(<?php echo $coul6;?>, 1);
	margin: 0;
}

.accueil .numberacc{
	position:absolute;
	top:0;;
	right:0;
	color:rgba(<?php echo $coul3;?>, 1);
	background-color:rgba(<?php echo $coul2;?>, 1);
	padding:0 14px;
	font-size:0.7em;
	box-sizing: border-box;
}


.accueil .full p{
	text-overflow: ellipsis;
	white-space: nowrap;
	overflow: hidden;
	text-align:left;
	margin: 0 0 0.5em 0;
}

.accueil .full:not(.statfull) .lignebar:nth-child(n+6){
	display:none;
}

.accueil .full,.accueil .lowwidth.fullwidth{
	flex-grow:1;
	width:100%;
	max-height:100%;
	position:relative;
	transition:all 0.2s;
	box-sizing: border-box;padding:0;
}

.accueil .lowwidth:not(.fullwidth),.accueil .lowwidth .full:not(.statfull){
	width:0;
	flex-grow:0;
	font-size:0;
	max-height:0;
	padding:0;
	transition:all 0.2s;
	
}



.accueil .full:hover{
	border: 2px solid rgba(<?php echo $coul1;?>, 1);
	padding: 12px;
	cursor:pointer;
}

.accueil .full:before{
	top:0px;
	right:0px;
	position:absolute;
	width:23px;
	height:23px;
	font-size:0.6em;
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f424";
	color: rgba(<?php echo $coul1;?>, 0);
}

.accueil .full:hover:before{
	top:6px;
	right:6px;
	font-size:1em;
	color: rgba(<?php echo $coul1;?>, 1);
}


.accueil .bouton:not(.aide) {
	width: 100%;
}

.accueil .size1 {
	font-size: 5em;
	margin-bottom: 20px
}

.accueil .size2 i{
	font-size: 4em;
}

svg tspan{
   font-family: FontAwesome;
   font-size: 2px;
}

svg text.highlight{
   fill:rgba(<?php echo $coul1;?>, 1) !important;
}
svg circle.highlight{
   stroke:rgba(<?php echo $coul1;?>, 1) !important;
}

.accueil .size2 .number{
	max-height: 4em;
}

.accueil .size2 > .col6+.col6{
	border-left: 1px solid rgba(<?php echo $coul1;?>, 0.2);
}

.accueil .size3 i{
	font-size: 3em;
}

.accueil .size3 .number{
	max-height: 3em;
}

.recent a {
	font-size: 0.8em;
	text-overflow: ellipsis;
	white-space: nowrap;
	overflow: hidden;
	width: 100%;
	text-decoration: none;
	box-sizing: border-box;
	padding: 0.5em;
	border-left: 5px solid rgba(<?php echo $coul1;?>, 1);
	background-color: rgba(<?php echo $coul8;?>, 1);
}

.recent a:nth-child(2n) {
	background-color: rgba(<?php echo $coul3;?>, 1);
	border-color: rgba(<?php echo $coul1;?>, 0.1);
}

.recent a:hover {
	border-color: rgba(<?php echo $coul2;?>, 1);
	color: rgba(<?php echo $coul3;?>, 1);
	background-color: rgba(<?php echo $coul1;?>, 1);
	transition: all 0.2s;
}

.recent a:after {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f061";
	margin-left:0.5em;
	opacity:0;
}

.recent a:hover:after {
	opacity:1
}


/*Commun page*/

.letternav a {
	padding: 0em 1em !important;
}

.space {
	width: 10px;
	display: inline-block
}

#copyright {
	font-size: 0.8em;
	position: fixed;
	right: 0;
	bottom: 0;
	padding: 2em;
}


/*aide*/

.aide {
	position: relative;
	background-color: rgba(<?php echo $coul3;?>, 1);
}

.aide:before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f128";
	color: rgba(<?php echo $coul1;?>, 1)
}

.aide span {
	opacity: 0;
	position: absolute;
	top: -99999px;
	left: 0px;
	text-align: left;
	z-index: 10;
	transition: all .2s;
	line-height: 2em;
	font-size: 1.1em;
	color: rgba(<?php echo $coul9;?>, 1);
	width: 400px;
	transition: top 0s;
	box-shadow: 0 1px 3px rgba(<?php echo $coul10;?>,0.12), 0 1px 2px rgba(<?php echo $coul10;?>,0.24);
}

.aide:hover span {
	top: 0px;
	opacity: 1;
	background-color: rgba(<?php echo $coul2;?>, 1);
	padding: 1em;
	z-index: 10;
}

.aide:hover {
	background-color: rgba(<?php echo $coul8;?>, 0);
}

.aide+h1,
.aide+h2,
.aide+h3 {
	line-height: 46px;
	margin: 0;
}


/*Bouton switch */

.switchcol {
	border-left: none !important;
}


.switch {
	position:relative;
	display:inline-block;
	width: 70px !important;
	height: 46px;
	line-height:30px;
	vertical-align:top;
}

.switch.mini {
	transform:scale(0.5);
	position:relative;
}

.switch ~ span{
	line-height:46px;
	background-color: rgba(<?php echo $coul2;?>, 1);
	color: rgba(<?php echo $coul9;?>, 1);
	opacity:0.5;
	padding-left: 10px;
	text-overflow: ellipsis;
	white-space: nowrap;
	overflow: hidden;
	-webkit-transition: .4s;
	transition: .4s;
	flex-grow:1;
}

.switch ~ span.checked{
	opacity:1;
}

.switch.mini ~ span{
	margin-left:-26px;
	padding-left:0px;
}

.switch input {
	opacity: 0;
	width: 0;
	height: 0;
}

.slider {
	position: absolute;
	cursor: pointer;
	top: 0;
	left: 0;
	right: 0;
	bottom: 0;
	background-color: rgba(<?php echo $coul1;?>, 1);
	-webkit-transition: .4s;
	transition: .4s;
}

.slider:before {
	position: absolute;
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	font-size:0.7em;
	content: "\f00d";
	height: 30px;
	left: 6px;
	bottom: 8px;
	padding: 0 10px;
	background-color: rgba(<?php echo $coul8;?>, 1);
	color: rgba(<?php echo $coul1;?>, 1);
	transition: .4s;
}

.switch input:checked+.slider {
	background-color: rgba(<?php echo $coul4;?>, 1);
}

.switch input:checked+.slider:before {
	transform: translateX(28px);
	content: "\f00c";
	color: rgba(<?php echo $coul7;?>, 1);
}

.invisible {
	display: none !important;
}


/*statistique*/

.statcircle .first,.statbar .first,.statgraph rect{
	animation: dash 2s linear reverse;
}

.statcircle {
	width: 100%;
	background: rgba(<?php echo $coul8;?>, 1);
	transform: rotate(-90deg);
}
.statcircle.duo {
	transform: rotate(180deg);
}

.statcircle circle{
	fill: none;
	stroke-width: 16;
}

.statcircle .masque,.statjauge .masque  {
	fill: rgba(<?php echo $coul3;?>, 1);
	box-shadow: inset -3px -3px 5px rgba(<?php echo $coul3;?>, 0.8), inset 3px 3px 5px rgba(<?php echo $coul1;?>, 0.2);
}

@keyframes dash {
	to {
		stroke-dasharray: 0 100;
	}
}

.statbar{
	width: 100%;
	background: rgba(<?php echo $coul8;?>, 1);
}

.statbar line {
	fill: none;
	stroke-width: 32;
}

.sortarrow {
	float: right;
}

.statcircle .statvalue {
	transform: rotate(90deg);
}

.statcircle.duo .statvalue {
	transform: rotate(180deg);
}

/*message*/

@keyframes disappear {
	0% {
		opacity: 1;
	}
	80% {
		opacity: 1;
	}
	100% {
		opacity: 0;
	}
}

.message {
	position: fixed;
	right: 10px;
	z-index: 100;
}

.message span {
	opacity: 0;
	padding: 11px 11px 12px 11px;
	animation: disappear 4s;
	color: rgba(<?php echo $coul3;?>, 1);
	position: relative;
	top: -1px;
	height: 23px;
	display: inline-block;
	right: 16px;
}

.message span::before {
	font-family: "Font Awesome 5 Free";
	font-weight: 900;
	content: "\f075";
	margin-right: 0.5em
}

#messageok span {
	background-color: rgba(<?php echo $coul4;?>, 1)
}

#messageavert span {
	background-color: rgba(<?php echo $coul4;?>, 0.5);
}

#messagenok span {
	background-color: rgba(<?php echo $coul6;?>, 1);
}


/* header */

header {
	position: fixed;
	z-index: 101;
	overflow:hidden;
	height: 50px;
	top: 0;
	max-width:100%;
	font-size: 0.8em;
	padding: 0.1em 0.5em;
	margin:7px 0 0 0;
	z-index:103;
	background-color: rgba(<?php echo $coul3;?>, 1);
	box-sizing: border-box;
	-moz-box-sizing: border-box;
	/* Firefox */
	vertical-align: top;
	transition:max-width 0.2s ease-in-out;
		box-shadow: 0px 0px 7px rgba(<?php echo $coul1;?>, 0.1);

}
header:not(:hover) {
	max-width:50px;
	box-shadow: none;
}

header:not(:hover) nav {
	top:-9999px;
}

/* footer */

footer {
	z-index: 103;
	text-align: right;
	margin: 20px 10px 0 0 ;
	font-size: 0.7em;
	box-sizing: border-box;
	-moz-box-sizing: border-box;
	/* Firefox */
	vertical-align: top;
}

footer a {
	padding: 0.5em 2em;
	background: linear-gradient(60deg,rgba(<?php echo $coul2;?>,1),rgba(<?php echo $coul7;?>,1));
	color:rgba(<?php echo $coul3;?>, 1) !important;
}


/*font*/

h1 {
	font-size: 1.5em;
	text-transform: uppercase;
}

h2 {
	font-size: 1.5em;
}

h3 {
	font-size: 1em;
	text-transform: uppercase;
}

p {
	margin: 0.8em 0 1.2em;
}

h1,
h2,
h3 {
	margin:0;
	line-height:46px;
}


/*corps*/

#content {
	width: 100%;
	padding: 0;
	margin-top: 58px;
	display: inline-block;
	box-sizing: border-box;
}

.hidden,
.lv {
	display: none;
}

.right {
	text-align: right;
}

.center {
	text-align: center;
}

.left {
	text-align: left;
}

.last {
	margin-bottom: 2em;
}

textarea {
	background-color: rgba(<?php echo $coul3;?>, 1);
	color: rgba(<?php echo $coul1;?>, 1);
	border: none;
	width: 100%;
	resize: none;
	padding: 0.5em 1em;
	margin:0;
	line-height:calc(46px - 1em);
	box-sizing: border-box;
}

/*parametre*/

.colgroup {
	width: calc(100%/12*8 - 80px);
}

.colgroupname {
	padding: 0px;
}

.coladmin {
	width: calc(100%/12*5 - 40px);
}

.colutilisateur {
	width: calc(100%/12*5 - 80px);
}

.colacces {
	width: calc(100%/12*6 - 80px);
}

.colnamemodule {
	width: calc(100%/12*9 - 80px);
}

.colcattag {
	width: calc(100%/12*4 - 80px);
}

.colcat select {
	width: calc(100% - 85px);
}

.avecbouton select,
.avecbouton input,
.avecbouton textarea,
.avecbouton span

 {
	width: calc(100% - 86px) !important;
}

.avantbouton { border-right:5px solid rgba(<?php echo $coul8;?>, 1); }

.param_module, .ongletdiv {
	position: absolute;
	top: -9999px;
	right:0;
}

.param_module.thismodule, .ongletdiv.thismodule {
	position: relative;
	z-index: 2;
	top: 0;
	right:0;
}

.ongletmodule {
	width: auto;
	margin-bottom: 5px
}

.fakeinput {
	background-color: rgba(<?php echo $coul2;?>, 1);
	color: rgba(<?php echo $coul9;?>, 1) !important;
	text-decoration:none !important;
	padding: 10px;
	margin: 0;
	width: 100%;
	box-sizing:border-box;
}

.fakeinput.nonvalid {
	background-color: rgba(<?php echo $coul1;?>, 1);
}



/*PAYPAL*/
.paypalform{height:21em;position:relative;}
.paypalform h3{margin:0;}
.paypalform:before{font-weight: 900;margin:20px 0 30px 0;font-size:5em;display:block;line-height:1em}
.paypalform.cinq:before{content:"\f164";font-family: "Font Awesome 5 Free";}
.paypalform.cinquante:before{content:"\f06c";font-family: "Font Awesome 5 Free";}
.paypalform.libre:before{content:"\f1ed";font-family: "Font Awesome 5 Brands";}

.paypalform input[type="submit"]{position:absolute;bottom:0;left:0;padding:0;margin:0 20px 20px 20px;width:calc(100% - 40px)}

/*update*/
#version{
	padding:0 11px;
	height: 23px;
	margin-right: 20px;
}

@media only screen and (min-width:900px) {
	.hidefixe {
		display: none;
	}
	.actionbutton {
		vertical-align:top;
		display: none;
	}
	
	.message .actionbutton {
		display: inline-block;
	}	
	.message {
		top: 10px
	}
}

@media only screen and (max-width:900px) {
	.hidefixe {
		display: inline-block;
	}
	.hidemob {
		display: none;
	}
	.message {
		bottom:0px;

		left: 0px;

		z-index: 120;

		width: 100%;

		text-align: center;

		padding: 3px 0 3px 0;

		box-sizing: border-box;
		background-color: rgba(<?php echo $coul1;?>, 1);

	}
	.message span {
		position: fixed;
		padding: 11px 0 0 0;
		bottom: 0;
		width: 100%;
		text-align: center;
		left: 0;
		height: 46px;
		pointer-events: none;
	}
	
	.message .bouton {
		border: 2px solid rgba(<?php echo $coul1;?>, 1);
	}	
	
	.space{display:none;}
	.container {
		width: 100%;
	}
	
	.private {
		min-height: 99vh;
		align-content: center;
		display: flex !important;
		margin:0;
	}
	
	.row:not(.samefix) > .col1,
	.row:not(.samefix) > .col2,
	.row:not(.samefix) > .col3,
	.row:not(.samefix) > .col4,
	.row:not(.samefix) > .col5,
	.row:not(.samefix) > .col6,
	.row:not(.samefix) > .col7,
	.row:not(.samefix) > .col8,
	.row:not(.samefix) > .col9,
	.row:not(.samefix) > .col10,
	.row:not(.samefix) > .col11,
	.row:not(.samefix) > .col12{
		width: 100%;
		padding: 0 0.5em;
	}
	.row:not(.samefix) {
		margin: -0.5em;
		display: block;
	}
	header {
		margin:0;
	}
	header .row {
		display: flex;
	}
	header:not(:hover) {
		max-width:100%;
		box-shadow: none;
	}
	header .col1 {
		width: calc(100%/12*1);
		padding: 10px;
		box-sizing: border-box;
		position: relative;
	}
	header .col5 {
		width: calc(100%/12*5);
		padding: 10px;
		box-sizing: border-box;
		position: relative;
	}
	header .col6 {
		width: calc(100%/12*6);
		padding: 10px;
		box-sizing: border-box;
		position: relative;
	}
	p {
		margin: 0;
	}
	.listing {
		padding: 0.5em 0;
	}
	.listing div:not(.row) {
		border-left: none !important;
	}
	nav{overflow-x:auto;}
	#navpage {
		font-size: 1em;
		line-height: 1em;
		height:inherit;
		max-width:100%;
		top:50px;
		overflow:auto;
	}
	#navpage span {
		display: none;
	}
	#navpage ul {
		display: block;

	}	
	#navpage li {
		display:inline-block;
	}	
	#navpage li a,.letternav a {
		padding:0.5em;padding: 0.5em 0.3em !important;
		width:inherit;
	}
	#navpage li a:before {
		padding: 0;
	}
	#mansory {
	columns: 1;
	}
	.container-princ>.access {
		margin-top:100px;
		padding-left:0;
	}
	#lienconfig {
	position:relative;
	bottom:0;
	}

	h1 {
		font-size: 1.5em;
		margin-bottom: -2em;
	}
	h2,
	h3,
	h4 {
		font-size: 1em;
		margin-top:1em;
	}
	.hidemob,
	.aide,
	.legende,
	.cartesvg,
	#infodept {
		display: none !important;
	}
	.formprojet {
		padding: 0.5em;
		position: relative;
	}
	
	.letter+.listing {
		width: 100%;
		box-sizing: border-box;
	}	
	
	.listing {
		padding:10px;
	}	
	
	.fiche {
		padding: 0.5em !important;
		box-sizing: border-box
	}
	.blocklisting {
		padding: 0 !important;
	}

	.coltimer {
		background-color: rgba(<?php echo $coul8;?>, 1);
	}
	.taches {
		padding: 0;
	}

	.listdoc .row > div {
		width: inherit
	}
	.letter{
		padding:0;
		margin:auto;
		margin-top:1em;
	}
	.letter	+.listing {
		background-color: rgba(<?php echo $coul8;?>, 1);
	}

	.listing .row > div:not(.colacces):not(.nopadding):not(.fiche) {
		min-height:0px;
		padding:0 10px !important;
	}
	
	.fiche,.fiche2 {
		padding: 14px !important;
		background-color: rgba(<?php echo $coul3;?>, 1);
	}
	
	.avecbouton select, .avecbouton input, .avecbouton textarea {

    width: calc(100% - 86px) !important;

	}
	.bibli>div {
		padding-bottom: 0;
		padding-top: 5px
	}
	.row.bilandiv {
		margin: 0.5em
	}
	.row.bilandiv>div {
		display: inline-block;
		width: 49%;
	}
	footer {
		opacity:0;
	}
	nav a {
		width: 3.5em;
	}

	.accueil .full:before{
		color: rgba(<?php echo $coul1;?>, 1);
	}
	
	.masonry1,.masonry2,.masonry3{width:100% }
	
}


<?php if (  $_SESSION['style'] == 'checked' ) { ?>
/*style arrondi*/

.border-none{border-radius:0 !important;}

.slider.round:before, .bouton {
	border-radius:10px;
}

label+input, label+select, label+.fakeinput, label+textarea {
	border-radius:0 14px 14px 0;
}

body,
textarea,
.legende,
.fiche,
.fiche2 ,
.groups_check,
.divimg,
.aide span,
.accueil .numberacc,
.accueil h2:before,
.statgraph rect,
.statbar,
#mansory .accueil:before,
.encart,
.accueil,
.slider,
.message span,
.accueil .full,
.container,
.border-all{
	border-radius:14px;
}

.border-right,
header,
#navpage,
.groupletter .fiche,
.recent a   {
	border-radius:0 14px 14px 0;

}

.border-left,
.letter,
.blocklisting {
	border-radius:14px 0 0 14px;

}
footer a {
	border-radius:14px 14px 0 0;
}
.lds-ellipsis div {
	border-radius: 50%;
}
.statcircle {
	border-radius:500px;
}
.statcircle.duo {
	border-radius: 0 0 500px 500px;
}

<?php };?>

@media print {
	/* All your print styles go here */
	header,
	footer,
	nav,
	#navpage,
	.aide,
	.message,
	#wait {
		display: none !important;
	}
	.container-princ > .access {
		padding:0;
	}
	body{font-size:0.7em}
	.container-princ {
		min-height: calc(100vh - 55px);
		max-width: inherit;
	}
	#mansory {
		columns: 2;
	}
	textarea {
		padding: 0;
		margin:0;
		line-height:23px;
	}
	hr{margin:0;border-top: 1px solid rgba(<?php echo $coul1;?>,1) !important; }
}
